# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'AlertAlertSchedule',
    'AlertAlertScheduleCron',
    'DatabaseReplicationConfiguration',
    'DynamicTableTargetLag',
    'ExternalFunctionArg',
    'ExternalFunctionHeader',
    'ExternalTableColumn',
    'ExternalTableTag',
    'FailoverGroupFromReplica',
    'FailoverGroupReplicationSchedule',
    'FailoverGroupReplicationScheduleCron',
    'FunctionArgument',
    'GrantOwnershipOn',
    'GrantOwnershipOnAll',
    'GrantOwnershipOnFuture',
    'GrantPrivilegesToAccountRoleOnAccountObject',
    'GrantPrivilegesToAccountRoleOnSchema',
    'GrantPrivilegesToAccountRoleOnSchemaObject',
    'GrantPrivilegesToAccountRoleOnSchemaObjectAll',
    'GrantPrivilegesToAccountRoleOnSchemaObjectFuture',
    'GrantPrivilegesToDatabaseRoleOnSchema',
    'GrantPrivilegesToDatabaseRoleOnSchemaObject',
    'GrantPrivilegesToDatabaseRoleOnSchemaObjectAll',
    'GrantPrivilegesToDatabaseRoleOnSchemaObjectFuture',
    'GrantPrivilegesToRoleOnAccountObject',
    'GrantPrivilegesToRoleOnSchema',
    'GrantPrivilegesToRoleOnSchemaObject',
    'GrantPrivilegesToRoleOnSchemaObjectAll',
    'GrantPrivilegesToRoleOnSchemaObjectFuture',
    'MaskingPolicySignature',
    'MaskingPolicySignatureColumn',
    'MaterializedViewTag',
    'ObjectParameterObjectIdentifier',
    'ProcedureArgument',
    'RoleTag',
    'SchemaTag',
    'StageTag',
    'TableColumn',
    'TableColumnDefault',
    'TableColumnIdentity',
    'TableConstraintForeignKeyProperties',
    'TableConstraintForeignKeyPropertiesReferences',
    'TablePrimaryKey',
    'TableTag',
    'TagAssociationObjectIdentifier',
    'ViewTag',
    'GetAccountsAccountResult',
    'GetAlertsAlertResult',
    'GetDatabaseRolesDatabaseRoleResult',
    'GetDatabasesDatabaseResult',
    'GetDatabasesDatabaseReplicationConfigurationResult',
    'GetDynamicTablesInResult',
    'GetDynamicTablesLikeResult',
    'GetDynamicTablesLimitResult',
    'GetDynamicTablesRecordResult',
    'GetExternalFunctionsExternalFunctionResult',
    'GetExternalTablesExternalTableResult',
    'GetFailoverGroupsFailoverGroupResult',
    'GetFileFormatsFileFormatResult',
    'GetFunctionsFunctionResult',
    'GetGrantsFutureGrantsInResult',
    'GetGrantsFutureGrantsToResult',
    'GetGrantsGrantResult',
    'GetGrantsGrantsOfResult',
    'GetGrantsGrantsOnResult',
    'GetGrantsGrantsToResult',
    'GetGrantsGrantsToShareResult',
    'GetMaskingPoliciesMaskingPolicyResult',
    'GetMaterializedViewsMaterializedViewResult',
    'GetParametersParameterResult',
    'GetPipesPipeResult',
    'GetProceduresProcedureResult',
    'GetResourceMonitorsResourceMonitorResult',
    'GetRolesRoleResult',
    'GetRowAccessPoliciesRowAccessPolicyResult',
    'GetSchemasSchemaResult',
    'GetSequencesSequenceResult',
    'GetSharesShareResult',
    'GetStagesStageResult',
    'GetStorageIntegrationsStorageIntegrationResult',
    'GetStreamsStreamResult',
    'GetTablesTableResult',
    'GetTasksTaskResult',
    'GetUsersUserResult',
    'GetViewsViewResult',
    'GetWarehousesWarehouseResult',
]

@pulumi.output_type
class AlertAlertSchedule(dict):
    def __init__(__self__, *,
                 cron: Optional['outputs.AlertAlertScheduleCron'] = None,
                 interval: Optional[int] = None):
        """
        :param 'AlertAlertScheduleCronArgs' cron: Specifies the cron expression for the alert. The cron expression must be in the following format: "minute hour day-of-month month day-of-week". The following values are supported: minute: 0-59 hour: 0-23 day-of-month: 1-31 month: 1-12 day-of-week: 0-6 (0 is Sunday)
        :param int interval: Specifies the interval in minutes for the alert schedule. The interval must be greater than 0 and less than 1440 (24 hours).
        """
        if cron is not None:
            pulumi.set(__self__, "cron", cron)
        if interval is not None:
            pulumi.set(__self__, "interval", interval)

    @property
    @pulumi.getter
    def cron(self) -> Optional['outputs.AlertAlertScheduleCron']:
        """
        Specifies the cron expression for the alert. The cron expression must be in the following format: "minute hour day-of-month month day-of-week". The following values are supported: minute: 0-59 hour: 0-23 day-of-month: 1-31 month: 1-12 day-of-week: 0-6 (0 is Sunday)
        """
        return pulumi.get(self, "cron")

    @property
    @pulumi.getter
    def interval(self) -> Optional[int]:
        """
        Specifies the interval in minutes for the alert schedule. The interval must be greater than 0 and less than 1440 (24 hours).
        """
        return pulumi.get(self, "interval")


@pulumi.output_type
class AlertAlertScheduleCron(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "timeZone":
            suggest = "time_zone"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AlertAlertScheduleCron. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AlertAlertScheduleCron.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AlertAlertScheduleCron.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 expression: str,
                 time_zone: str):
        """
        :param str expression: Specifies the cron expression for the alert. The cron expression must be in the following format: "minute hour day-of-month month day-of-week". The following values are supported: minute: 0-59 hour: 0-23 day-of-month: 1-31 month: 1-12 day-of-week: 0-6 (0 is Sunday)
        :param str time_zone: Specifies the time zone for alert refresh.
        """
        pulumi.set(__self__, "expression", expression)
        pulumi.set(__self__, "time_zone", time_zone)

    @property
    @pulumi.getter
    def expression(self) -> str:
        """
        Specifies the cron expression for the alert. The cron expression must be in the following format: "minute hour day-of-month month day-of-week". The following values are supported: minute: 0-59 hour: 0-23 day-of-month: 1-31 month: 1-12 day-of-week: 0-6 (0 is Sunday)
        """
        return pulumi.get(self, "expression")

    @property
    @pulumi.getter(name="timeZone")
    def time_zone(self) -> str:
        """
        Specifies the time zone for alert refresh.
        """
        return pulumi.get(self, "time_zone")


@pulumi.output_type
class DatabaseReplicationConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "ignoreEditionCheck":
            suggest = "ignore_edition_check"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DatabaseReplicationConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DatabaseReplicationConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DatabaseReplicationConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 accounts: Sequence[str],
                 ignore_edition_check: Optional[bool] = None):
        pulumi.set(__self__, "accounts", accounts)
        if ignore_edition_check is not None:
            pulumi.set(__self__, "ignore_edition_check", ignore_edition_check)

    @property
    @pulumi.getter
    def accounts(self) -> Sequence[str]:
        return pulumi.get(self, "accounts")

    @property
    @pulumi.getter(name="ignoreEditionCheck")
    def ignore_edition_check(self) -> Optional[bool]:
        return pulumi.get(self, "ignore_edition_check")


@pulumi.output_type
class DynamicTableTargetLag(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "maximumDuration":
            suggest = "maximum_duration"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DynamicTableTargetLag. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DynamicTableTargetLag.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DynamicTableTargetLag.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 downstream: Optional[bool] = None,
                 maximum_duration: Optional[str] = None):
        """
        :param bool downstream: Specifies whether the target lag time is downstream.
        :param str maximum_duration: Specifies the maximum target lag time for the dynamic table.
        """
        if downstream is not None:
            pulumi.set(__self__, "downstream", downstream)
        if maximum_duration is not None:
            pulumi.set(__self__, "maximum_duration", maximum_duration)

    @property
    @pulumi.getter
    def downstream(self) -> Optional[bool]:
        """
        Specifies whether the target lag time is downstream.
        """
        return pulumi.get(self, "downstream")

    @property
    @pulumi.getter(name="maximumDuration")
    def maximum_duration(self) -> Optional[str]:
        """
        Specifies the maximum target lag time for the dynamic table.
        """
        return pulumi.get(self, "maximum_duration")


@pulumi.output_type
class ExternalFunctionArg(dict):
    def __init__(__self__, *,
                 name: str,
                 type: str):
        """
        :param str name: Argument name
        :param str type: Argument type, e.g. VARCHAR
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Argument name
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Argument type, e.g. VARCHAR
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class ExternalFunctionHeader(dict):
    def __init__(__self__, *,
                 name: str,
                 value: str):
        """
        :param str name: Header name
        :param str value: Header value
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Header name
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Header value
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class ExternalTableColumn(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "as":
            suggest = "as_"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ExternalTableColumn. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ExternalTableColumn.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ExternalTableColumn.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 as_: str,
                 name: str,
                 type: str):
        """
        :param str as_: String that specifies the expression for the column. When queried, the column returns results derived from this expression.
        :param str name: Column name
        :param str type: Column type, e.g. VARIANT
        """
        pulumi.set(__self__, "as_", as_)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="as")
    def as_(self) -> str:
        """
        String that specifies the expression for the column. When queried, the column returns results derived from this expression.
        """
        return pulumi.get(self, "as_")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Column name
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Column type, e.g. VARIANT
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class ExternalTableTag(dict):
    def __init__(__self__, *,
                 name: str,
                 value: str,
                 database: Optional[str] = None,
                 schema: Optional[str] = None):
        """
        :param str name: Tag name, e.g. department.
        :param str value: Tag value, e.g. marketing_info.
        :param str database: Name of the database that the tag was created in.
        :param str schema: Name of the schema that the tag was created in.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "value", value)
        if database is not None:
            pulumi.set(__self__, "database", database)
        if schema is not None:
            pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Tag name, e.g. department.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Tag value, e.g. marketing_info.
        """
        return pulumi.get(self, "value")

    @property
    @pulumi.getter
    def database(self) -> Optional[str]:
        """
        Name of the database that the tag was created in.
        """
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def schema(self) -> Optional[str]:
        """
        Name of the schema that the tag was created in.
        """
        return pulumi.get(self, "schema")


@pulumi.output_type
class FailoverGroupFromReplica(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "organizationName":
            suggest = "organization_name"
        elif key == "sourceAccountName":
            suggest = "source_account_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in FailoverGroupFromReplica. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        FailoverGroupFromReplica.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        FailoverGroupFromReplica.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 name: str,
                 organization_name: str,
                 source_account_name: str):
        """
        :param str name: Identifier for the primary failover group in the source account.
        :param str organization_name: Name of your Snowflake organization.
        :param str source_account_name: Source account from which you are enabling replication and failover of the specified objects.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "organization_name", organization_name)
        pulumi.set(__self__, "source_account_name", source_account_name)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Identifier for the primary failover group in the source account.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="organizationName")
    def organization_name(self) -> str:
        """
        Name of your Snowflake organization.
        """
        return pulumi.get(self, "organization_name")

    @property
    @pulumi.getter(name="sourceAccountName")
    def source_account_name(self) -> str:
        """
        Source account from which you are enabling replication and failover of the specified objects.
        """
        return pulumi.get(self, "source_account_name")


@pulumi.output_type
class FailoverGroupReplicationSchedule(dict):
    def __init__(__self__, *,
                 cron: Optional['outputs.FailoverGroupReplicationScheduleCron'] = None,
                 interval: Optional[int] = None):
        """
        :param 'FailoverGroupReplicationScheduleCronArgs' cron: Specifies the cron expression for the replication schedule. The cron expression must be in the following format: "minute hour day-of-month month day-of-week". The following values are supported: minute: 0-59 hour: 0-23 day-of-month: 1-31 month: 1-12 day-of-week: 0-6 (0 is Sunday)
        :param int interval: Specifies the interval in minutes for the replication schedule. The interval must be greater than 0 and less than 1440 (24 hours).
        """
        if cron is not None:
            pulumi.set(__self__, "cron", cron)
        if interval is not None:
            pulumi.set(__self__, "interval", interval)

    @property
    @pulumi.getter
    def cron(self) -> Optional['outputs.FailoverGroupReplicationScheduleCron']:
        """
        Specifies the cron expression for the replication schedule. The cron expression must be in the following format: "minute hour day-of-month month day-of-week". The following values are supported: minute: 0-59 hour: 0-23 day-of-month: 1-31 month: 1-12 day-of-week: 0-6 (0 is Sunday)
        """
        return pulumi.get(self, "cron")

    @property
    @pulumi.getter
    def interval(self) -> Optional[int]:
        """
        Specifies the interval in minutes for the replication schedule. The interval must be greater than 0 and less than 1440 (24 hours).
        """
        return pulumi.get(self, "interval")


@pulumi.output_type
class FailoverGroupReplicationScheduleCron(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "timeZone":
            suggest = "time_zone"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in FailoverGroupReplicationScheduleCron. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        FailoverGroupReplicationScheduleCron.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        FailoverGroupReplicationScheduleCron.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 expression: str,
                 time_zone: str):
        """
        :param str expression: Specifies the cron expression for the replication schedule. The cron expression must be in the following format: "minute hour day-of-month month day-of-week". The following values are supported: minute: 0-59 hour: 0-23 day-of-month: 1-31 month: 1-12 day-of-week: 0-6 (0 is Sunday)
        :param str time_zone: Specifies the time zone for secondary group refresh.
        """
        pulumi.set(__self__, "expression", expression)
        pulumi.set(__self__, "time_zone", time_zone)

    @property
    @pulumi.getter
    def expression(self) -> str:
        """
        Specifies the cron expression for the replication schedule. The cron expression must be in the following format: "minute hour day-of-month month day-of-week". The following values are supported: minute: 0-59 hour: 0-23 day-of-month: 1-31 month: 1-12 day-of-week: 0-6 (0 is Sunday)
        """
        return pulumi.get(self, "expression")

    @property
    @pulumi.getter(name="timeZone")
    def time_zone(self) -> str:
        """
        Specifies the time zone for secondary group refresh.
        """
        return pulumi.get(self, "time_zone")


@pulumi.output_type
class FunctionArgument(dict):
    def __init__(__self__, *,
                 name: str,
                 type: str):
        """
        :param str name: The argument name
        :param str type: The argument type
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The argument name
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The argument type
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class GrantOwnershipOn(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "objectName":
            suggest = "object_name"
        elif key == "objectType":
            suggest = "object_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GrantOwnershipOn. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GrantOwnershipOn.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GrantOwnershipOn.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 all: Optional['outputs.GrantOwnershipOnAll'] = None,
                 future: Optional['outputs.GrantOwnershipOnFuture'] = None,
                 object_name: Optional[str] = None,
                 object_type: Optional[str] = None):
        """
        :param 'GrantOwnershipOnAllArgs' all: Configures the privilege to be granted on all objects in either a database or schema.
        :param 'GrantOwnershipOnFutureArgs' future: Configures the privilege to be granted on all objects in either a database or schema.
        :param str object_name: Specifies the identifier for the object on which you are transferring ownership.
        :param str object_type: Specifies the type of object on which you are transferring ownership. Available values are: AGGREGATION POLICY | ALERT | AUTHENTICATION POLICY | COMPUTE POOL | DATA METRIC FUNCTION | DATABASE | DATABASE ROLE | DYNAMIC TABLE | EVENT TABLE | EXTERNAL TABLE | EXTERNAL VOLUME | FAILOVER GROUP | FILE FORMAT | FUNCTION | GIT REPOSITORY | HYBRID TABLE | ICEBERG TABLE | IMAGE REPOSITORY | INTEGRATION | MATERIALIZED VIEW | NETWORK POLICY | NETWORK RULE | PACKAGES POLICY | PIPE | PROCEDURE | MASKING POLICY | PASSWORD POLICY | PROJECTION POLICY | REPLICATION GROUP | ROLE | ROW ACCESS POLICY | SCHEMA | SESSION POLICY | SECRET | SEQUENCE | STAGE | STREAM | TABLE | TAG | TASK | USER | VIEW | WAREHOUSE
        """
        if all is not None:
            pulumi.set(__self__, "all", all)
        if future is not None:
            pulumi.set(__self__, "future", future)
        if object_name is not None:
            pulumi.set(__self__, "object_name", object_name)
        if object_type is not None:
            pulumi.set(__self__, "object_type", object_type)

    @property
    @pulumi.getter
    def all(self) -> Optional['outputs.GrantOwnershipOnAll']:
        """
        Configures the privilege to be granted on all objects in either a database or schema.
        """
        return pulumi.get(self, "all")

    @property
    @pulumi.getter
    def future(self) -> Optional['outputs.GrantOwnershipOnFuture']:
        """
        Configures the privilege to be granted on all objects in either a database or schema.
        """
        return pulumi.get(self, "future")

    @property
    @pulumi.getter(name="objectName")
    def object_name(self) -> Optional[str]:
        """
        Specifies the identifier for the object on which you are transferring ownership.
        """
        return pulumi.get(self, "object_name")

    @property
    @pulumi.getter(name="objectType")
    def object_type(self) -> Optional[str]:
        """
        Specifies the type of object on which you are transferring ownership. Available values are: AGGREGATION POLICY | ALERT | AUTHENTICATION POLICY | COMPUTE POOL | DATA METRIC FUNCTION | DATABASE | DATABASE ROLE | DYNAMIC TABLE | EVENT TABLE | EXTERNAL TABLE | EXTERNAL VOLUME | FAILOVER GROUP | FILE FORMAT | FUNCTION | GIT REPOSITORY | HYBRID TABLE | ICEBERG TABLE | IMAGE REPOSITORY | INTEGRATION | MATERIALIZED VIEW | NETWORK POLICY | NETWORK RULE | PACKAGES POLICY | PIPE | PROCEDURE | MASKING POLICY | PASSWORD POLICY | PROJECTION POLICY | REPLICATION GROUP | ROLE | ROW ACCESS POLICY | SCHEMA | SESSION POLICY | SECRET | SEQUENCE | STAGE | STREAM | TABLE | TAG | TASK | USER | VIEW | WAREHOUSE
        """
        return pulumi.get(self, "object_type")


@pulumi.output_type
class GrantOwnershipOnAll(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "objectTypePlural":
            suggest = "object_type_plural"
        elif key == "inDatabase":
            suggest = "in_database"
        elif key == "inSchema":
            suggest = "in_schema"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GrantOwnershipOnAll. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GrantOwnershipOnAll.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GrantOwnershipOnAll.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 object_type_plural: str,
                 in_database: Optional[str] = None,
                 in_schema: Optional[str] = None):
        """
        :param str object_type_plural: Specifies the type of object in plural form on which you are transferring ownership. Available values are: AGGREGATION POLICIES | ALERTS | AUTHENTICATION POLICIES | COMPUTE POOLS | DATA METRIC FUNCTIONS | DATABASES | DATABASE ROLES | DYNAMIC TABLES | EVENT TABLES | EXTERNAL TABLES | EXTERNAL VOLUMES | FAILOVER GROUPS | FILE FORMATS | FUNCTIONS | GIT REPOSITORIES | HYBRID TABLES | ICEBERG TABLES | IMAGE REPOSITORIES | INTEGRATIONS | MATERIALIZED VIEWS | NETWORK POLICIES | NETWORK RULES | PACKAGES POLICIES | PIPES | PROCEDURES | MASKING POLICIES | PASSWORD POLICIES | PROJECTION POLICIES | REPLICATION GROUPS | ROLES | ROW ACCESS POLICIES | SCHEMAS | SESSION POLICIES | SECRETS | SEQUENCES | STAGES | STREAMS | TABLES | TAGS | TASKS | USERS | VIEWS | WAREHOUSES. For more information head over to [Snowflake documentation](https://docs.snowflake.com/en/sql-reference/sql/grant-ownership#required-parameters).
        :param str in_database: The fully qualified name of the database.
        :param str in_schema: The fully qualified name of the schema.
        """
        pulumi.set(__self__, "object_type_plural", object_type_plural)
        if in_database is not None:
            pulumi.set(__self__, "in_database", in_database)
        if in_schema is not None:
            pulumi.set(__self__, "in_schema", in_schema)

    @property
    @pulumi.getter(name="objectTypePlural")
    def object_type_plural(self) -> str:
        """
        Specifies the type of object in plural form on which you are transferring ownership. Available values are: AGGREGATION POLICIES | ALERTS | AUTHENTICATION POLICIES | COMPUTE POOLS | DATA METRIC FUNCTIONS | DATABASES | DATABASE ROLES | DYNAMIC TABLES | EVENT TABLES | EXTERNAL TABLES | EXTERNAL VOLUMES | FAILOVER GROUPS | FILE FORMATS | FUNCTIONS | GIT REPOSITORIES | HYBRID TABLES | ICEBERG TABLES | IMAGE REPOSITORIES | INTEGRATIONS | MATERIALIZED VIEWS | NETWORK POLICIES | NETWORK RULES | PACKAGES POLICIES | PIPES | PROCEDURES | MASKING POLICIES | PASSWORD POLICIES | PROJECTION POLICIES | REPLICATION GROUPS | ROLES | ROW ACCESS POLICIES | SCHEMAS | SESSION POLICIES | SECRETS | SEQUENCES | STAGES | STREAMS | TABLES | TAGS | TASKS | USERS | VIEWS | WAREHOUSES. For more information head over to [Snowflake documentation](https://docs.snowflake.com/en/sql-reference/sql/grant-ownership#required-parameters).
        """
        return pulumi.get(self, "object_type_plural")

    @property
    @pulumi.getter(name="inDatabase")
    def in_database(self) -> Optional[str]:
        """
        The fully qualified name of the database.
        """
        return pulumi.get(self, "in_database")

    @property
    @pulumi.getter(name="inSchema")
    def in_schema(self) -> Optional[str]:
        """
        The fully qualified name of the schema.
        """
        return pulumi.get(self, "in_schema")


@pulumi.output_type
class GrantOwnershipOnFuture(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "objectTypePlural":
            suggest = "object_type_plural"
        elif key == "inDatabase":
            suggest = "in_database"
        elif key == "inSchema":
            suggest = "in_schema"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GrantOwnershipOnFuture. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GrantOwnershipOnFuture.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GrantOwnershipOnFuture.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 object_type_plural: str,
                 in_database: Optional[str] = None,
                 in_schema: Optional[str] = None):
        """
        :param str object_type_plural: Specifies the type of object in plural form on which you are transferring ownership. Available values are: AGGREGATION POLICIES | ALERTS | AUTHENTICATION POLICIES | COMPUTE POOLS | DATA METRIC FUNCTIONS | DATABASES | DATABASE ROLES | DYNAMIC TABLES | EVENT TABLES | EXTERNAL TABLES | EXTERNAL VOLUMES | FAILOVER GROUPS | FILE FORMATS | FUNCTIONS | GIT REPOSITORIES | HYBRID TABLES | ICEBERG TABLES | IMAGE REPOSITORIES | INTEGRATIONS | MATERIALIZED VIEWS | NETWORK POLICIES | NETWORK RULES | PACKAGES POLICIES | PIPES | PROCEDURES | MASKING POLICIES | PASSWORD POLICIES | PROJECTION POLICIES | REPLICATION GROUPS | ROLES | ROW ACCESS POLICIES | SCHEMAS | SESSION POLICIES | SECRETS | SEQUENCES | STAGES | STREAMS | TABLES | TAGS | TASKS | USERS | VIEWS | WAREHOUSES. For more information head over to [Snowflake documentation](https://docs.snowflake.com/en/sql-reference/sql/grant-ownership#required-parameters).
        :param str in_database: The fully qualified name of the database.
        :param str in_schema: The fully qualified name of the schema.
        """
        pulumi.set(__self__, "object_type_plural", object_type_plural)
        if in_database is not None:
            pulumi.set(__self__, "in_database", in_database)
        if in_schema is not None:
            pulumi.set(__self__, "in_schema", in_schema)

    @property
    @pulumi.getter(name="objectTypePlural")
    def object_type_plural(self) -> str:
        """
        Specifies the type of object in plural form on which you are transferring ownership. Available values are: AGGREGATION POLICIES | ALERTS | AUTHENTICATION POLICIES | COMPUTE POOLS | DATA METRIC FUNCTIONS | DATABASES | DATABASE ROLES | DYNAMIC TABLES | EVENT TABLES | EXTERNAL TABLES | EXTERNAL VOLUMES | FAILOVER GROUPS | FILE FORMATS | FUNCTIONS | GIT REPOSITORIES | HYBRID TABLES | ICEBERG TABLES | IMAGE REPOSITORIES | INTEGRATIONS | MATERIALIZED VIEWS | NETWORK POLICIES | NETWORK RULES | PACKAGES POLICIES | PIPES | PROCEDURES | MASKING POLICIES | PASSWORD POLICIES | PROJECTION POLICIES | REPLICATION GROUPS | ROLES | ROW ACCESS POLICIES | SCHEMAS | SESSION POLICIES | SECRETS | SEQUENCES | STAGES | STREAMS | TABLES | TAGS | TASKS | USERS | VIEWS | WAREHOUSES. For more information head over to [Snowflake documentation](https://docs.snowflake.com/en/sql-reference/sql/grant-ownership#required-parameters).
        """
        return pulumi.get(self, "object_type_plural")

    @property
    @pulumi.getter(name="inDatabase")
    def in_database(self) -> Optional[str]:
        """
        The fully qualified name of the database.
        """
        return pulumi.get(self, "in_database")

    @property
    @pulumi.getter(name="inSchema")
    def in_schema(self) -> Optional[str]:
        """
        The fully qualified name of the schema.
        """
        return pulumi.get(self, "in_schema")


@pulumi.output_type
class GrantPrivilegesToAccountRoleOnAccountObject(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "objectName":
            suggest = "object_name"
        elif key == "objectType":
            suggest = "object_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GrantPrivilegesToAccountRoleOnAccountObject. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GrantPrivilegesToAccountRoleOnAccountObject.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GrantPrivilegesToAccountRoleOnAccountObject.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 object_name: str,
                 object_type: str):
        """
        :param str object_name: The fully qualified name of the object on which privileges will be granted.
        :param str object_type: The object type of the account object on which privileges will be granted. Valid values are: USER | RESOURCE MONITOR | WAREHOUSE | COMPUTE POOL | DATABASE | INTEGRATION | FAILOVER GROUP | REPLICATION GROUP | EXTERNAL VOLUME
        """
        pulumi.set(__self__, "object_name", object_name)
        pulumi.set(__self__, "object_type", object_type)

    @property
    @pulumi.getter(name="objectName")
    def object_name(self) -> str:
        """
        The fully qualified name of the object on which privileges will be granted.
        """
        return pulumi.get(self, "object_name")

    @property
    @pulumi.getter(name="objectType")
    def object_type(self) -> str:
        """
        The object type of the account object on which privileges will be granted. Valid values are: USER | RESOURCE MONITOR | WAREHOUSE | COMPUTE POOL | DATABASE | INTEGRATION | FAILOVER GROUP | REPLICATION GROUP | EXTERNAL VOLUME
        """
        return pulumi.get(self, "object_type")


@pulumi.output_type
class GrantPrivilegesToAccountRoleOnSchema(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "allSchemasInDatabase":
            suggest = "all_schemas_in_database"
        elif key == "futureSchemasInDatabase":
            suggest = "future_schemas_in_database"
        elif key == "schemaName":
            suggest = "schema_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GrantPrivilegesToAccountRoleOnSchema. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GrantPrivilegesToAccountRoleOnSchema.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GrantPrivilegesToAccountRoleOnSchema.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 all_schemas_in_database: Optional[str] = None,
                 future_schemas_in_database: Optional[str] = None,
                 schema_name: Optional[str] = None):
        """
        :param str all_schemas_in_database: The fully qualified name of the database.
        :param str future_schemas_in_database: The fully qualified name of the database.
        :param str schema_name: The fully qualified name of the schema.
        """
        if all_schemas_in_database is not None:
            pulumi.set(__self__, "all_schemas_in_database", all_schemas_in_database)
        if future_schemas_in_database is not None:
            pulumi.set(__self__, "future_schemas_in_database", future_schemas_in_database)
        if schema_name is not None:
            pulumi.set(__self__, "schema_name", schema_name)

    @property
    @pulumi.getter(name="allSchemasInDatabase")
    def all_schemas_in_database(self) -> Optional[str]:
        """
        The fully qualified name of the database.
        """
        return pulumi.get(self, "all_schemas_in_database")

    @property
    @pulumi.getter(name="futureSchemasInDatabase")
    def future_schemas_in_database(self) -> Optional[str]:
        """
        The fully qualified name of the database.
        """
        return pulumi.get(self, "future_schemas_in_database")

    @property
    @pulumi.getter(name="schemaName")
    def schema_name(self) -> Optional[str]:
        """
        The fully qualified name of the schema.
        """
        return pulumi.get(self, "schema_name")


@pulumi.output_type
class GrantPrivilegesToAccountRoleOnSchemaObject(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "objectName":
            suggest = "object_name"
        elif key == "objectType":
            suggest = "object_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GrantPrivilegesToAccountRoleOnSchemaObject. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GrantPrivilegesToAccountRoleOnSchemaObject.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GrantPrivilegesToAccountRoleOnSchemaObject.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 all: Optional['outputs.GrantPrivilegesToAccountRoleOnSchemaObjectAll'] = None,
                 future: Optional['outputs.GrantPrivilegesToAccountRoleOnSchemaObjectFuture'] = None,
                 object_name: Optional[str] = None,
                 object_type: Optional[str] = None):
        """
        :param 'GrantPrivilegesToAccountRoleOnSchemaObjectAllArgs' all: Configures the privilege to be granted on all objects in either a database or schema.
        :param 'GrantPrivilegesToAccountRoleOnSchemaObjectFutureArgs' future: Configures the privilege to be granted on future objects in either a database or schema.
        :param str object_name: The fully qualified name of the object on which privileges will be granted.
        :param str object_type: The object type of the schema object on which privileges will be granted. Valid values are: AGGREGATION POLICY | ALERT | AUTHENTICATION POLICY | DATA METRIC FUNCTION | DYNAMIC TABLE | EVENT TABLE | EXTERNAL TABLE | FILE FORMAT | FUNCTION | GIT REPOSITORY | HYBRID TABLE | IMAGE REPOSITORY | ICEBERG TABLE | MASKING POLICY | MATERIALIZED VIEW | MODEL | NETWORK RULE | PACKAGES POLICY | PASSWORD POLICY | PIPE | PROCEDURE | PROJECTION POLICY | ROW ACCESS POLICY | SECRET | SERVICE | SESSION POLICY | SEQUENCE | STAGE | STREAM | TABLE | TAG | TASK | VIEW | STREAMLIT
        """
        if all is not None:
            pulumi.set(__self__, "all", all)
        if future is not None:
            pulumi.set(__self__, "future", future)
        if object_name is not None:
            pulumi.set(__self__, "object_name", object_name)
        if object_type is not None:
            pulumi.set(__self__, "object_type", object_type)

    @property
    @pulumi.getter
    def all(self) -> Optional['outputs.GrantPrivilegesToAccountRoleOnSchemaObjectAll']:
        """
        Configures the privilege to be granted on all objects in either a database or schema.
        """
        return pulumi.get(self, "all")

    @property
    @pulumi.getter
    def future(self) -> Optional['outputs.GrantPrivilegesToAccountRoleOnSchemaObjectFuture']:
        """
        Configures the privilege to be granted on future objects in either a database or schema.
        """
        return pulumi.get(self, "future")

    @property
    @pulumi.getter(name="objectName")
    def object_name(self) -> Optional[str]:
        """
        The fully qualified name of the object on which privileges will be granted.
        """
        return pulumi.get(self, "object_name")

    @property
    @pulumi.getter(name="objectType")
    def object_type(self) -> Optional[str]:
        """
        The object type of the schema object on which privileges will be granted. Valid values are: AGGREGATION POLICY | ALERT | AUTHENTICATION POLICY | DATA METRIC FUNCTION | DYNAMIC TABLE | EVENT TABLE | EXTERNAL TABLE | FILE FORMAT | FUNCTION | GIT REPOSITORY | HYBRID TABLE | IMAGE REPOSITORY | ICEBERG TABLE | MASKING POLICY | MATERIALIZED VIEW | MODEL | NETWORK RULE | PACKAGES POLICY | PASSWORD POLICY | PIPE | PROCEDURE | PROJECTION POLICY | ROW ACCESS POLICY | SECRET | SERVICE | SESSION POLICY | SEQUENCE | STAGE | STREAM | TABLE | TAG | TASK | VIEW | STREAMLIT
        """
        return pulumi.get(self, "object_type")


@pulumi.output_type
class GrantPrivilegesToAccountRoleOnSchemaObjectAll(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "objectTypePlural":
            suggest = "object_type_plural"
        elif key == "inDatabase":
            suggest = "in_database"
        elif key == "inSchema":
            suggest = "in_schema"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GrantPrivilegesToAccountRoleOnSchemaObjectAll. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GrantPrivilegesToAccountRoleOnSchemaObjectAll.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GrantPrivilegesToAccountRoleOnSchemaObjectAll.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 object_type_plural: str,
                 in_database: Optional[str] = None,
                 in_schema: Optional[str] = None):
        """
        :param str object_type_plural: The plural object type of the schema object on which privileges will be granted. Valid values are: AGGREGATION POLICIES | ALERTS | AUTHENTICATION POLICIES | DATA METRIC FUNCTIONS | DYNAMIC TABLES | EVENT TABLES | EXTERNAL TABLES | FILE FORMATS | FUNCTIONS | GIT REPOSITORIES | HYBRID TABLES | IMAGE REPOSITORIES | ICEBERG TABLES | MASKING POLICIES | MATERIALIZED VIEWS | MODELS | NETWORK RULES | PACKAGES POLICIES | PASSWORD POLICIES | PIPES | PROCEDURES | PROJECTION POLICIES | ROW ACCESS POLICIES | SECRETS | SERVICES | SESSION POLICIES | SEQUENCES | STAGES | STREAMS | TABLES | TAGS | TASKS | VIEWS | STREAMLITS.
        """
        pulumi.set(__self__, "object_type_plural", object_type_plural)
        if in_database is not None:
            pulumi.set(__self__, "in_database", in_database)
        if in_schema is not None:
            pulumi.set(__self__, "in_schema", in_schema)

    @property
    @pulumi.getter(name="objectTypePlural")
    def object_type_plural(self) -> str:
        """
        The plural object type of the schema object on which privileges will be granted. Valid values are: AGGREGATION POLICIES | ALERTS | AUTHENTICATION POLICIES | DATA METRIC FUNCTIONS | DYNAMIC TABLES | EVENT TABLES | EXTERNAL TABLES | FILE FORMATS | FUNCTIONS | GIT REPOSITORIES | HYBRID TABLES | IMAGE REPOSITORIES | ICEBERG TABLES | MASKING POLICIES | MATERIALIZED VIEWS | MODELS | NETWORK RULES | PACKAGES POLICIES | PASSWORD POLICIES | PIPES | PROCEDURES | PROJECTION POLICIES | ROW ACCESS POLICIES | SECRETS | SERVICES | SESSION POLICIES | SEQUENCES | STAGES | STREAMS | TABLES | TAGS | TASKS | VIEWS | STREAMLITS.
        """
        return pulumi.get(self, "object_type_plural")

    @property
    @pulumi.getter(name="inDatabase")
    def in_database(self) -> Optional[str]:
        return pulumi.get(self, "in_database")

    @property
    @pulumi.getter(name="inSchema")
    def in_schema(self) -> Optional[str]:
        return pulumi.get(self, "in_schema")


@pulumi.output_type
class GrantPrivilegesToAccountRoleOnSchemaObjectFuture(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "objectTypePlural":
            suggest = "object_type_plural"
        elif key == "inDatabase":
            suggest = "in_database"
        elif key == "inSchema":
            suggest = "in_schema"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GrantPrivilegesToAccountRoleOnSchemaObjectFuture. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GrantPrivilegesToAccountRoleOnSchemaObjectFuture.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GrantPrivilegesToAccountRoleOnSchemaObjectFuture.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 object_type_plural: str,
                 in_database: Optional[str] = None,
                 in_schema: Optional[str] = None):
        """
        :param str object_type_plural: The plural object type of the schema object on which privileges will be granted. Valid values are: ALERTS | AUTHENTICATION POLICIES | DATA METRIC FUNCTIONS | DYNAMIC TABLES | EVENT TABLES | EXTERNAL TABLES | FILE FORMATS | FUNCTIONS | GIT REPOSITORIES | HYBRID TABLES | ICEBERG TABLES | MATERIALIZED VIEWS | MODELS | NETWORK RULES | PASSWORD POLICIES | PIPES | PROCEDURES | SECRETS | SERVICES | SEQUENCES | STAGES | STREAMS | TABLES | TASKS | VIEWS.
        """
        pulumi.set(__self__, "object_type_plural", object_type_plural)
        if in_database is not None:
            pulumi.set(__self__, "in_database", in_database)
        if in_schema is not None:
            pulumi.set(__self__, "in_schema", in_schema)

    @property
    @pulumi.getter(name="objectTypePlural")
    def object_type_plural(self) -> str:
        """
        The plural object type of the schema object on which privileges will be granted. Valid values are: ALERTS | AUTHENTICATION POLICIES | DATA METRIC FUNCTIONS | DYNAMIC TABLES | EVENT TABLES | EXTERNAL TABLES | FILE FORMATS | FUNCTIONS | GIT REPOSITORIES | HYBRID TABLES | ICEBERG TABLES | MATERIALIZED VIEWS | MODELS | NETWORK RULES | PASSWORD POLICIES | PIPES | PROCEDURES | SECRETS | SERVICES | SEQUENCES | STAGES | STREAMS | TABLES | TASKS | VIEWS.
        """
        return pulumi.get(self, "object_type_plural")

    @property
    @pulumi.getter(name="inDatabase")
    def in_database(self) -> Optional[str]:
        return pulumi.get(self, "in_database")

    @property
    @pulumi.getter(name="inSchema")
    def in_schema(self) -> Optional[str]:
        return pulumi.get(self, "in_schema")


@pulumi.output_type
class GrantPrivilegesToDatabaseRoleOnSchema(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "allSchemasInDatabase":
            suggest = "all_schemas_in_database"
        elif key == "futureSchemasInDatabase":
            suggest = "future_schemas_in_database"
        elif key == "schemaName":
            suggest = "schema_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GrantPrivilegesToDatabaseRoleOnSchema. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GrantPrivilegesToDatabaseRoleOnSchema.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GrantPrivilegesToDatabaseRoleOnSchema.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 all_schemas_in_database: Optional[str] = None,
                 future_schemas_in_database: Optional[str] = None,
                 schema_name: Optional[str] = None):
        """
        :param str all_schemas_in_database: The fully qualified name of the database.
        :param str future_schemas_in_database: The fully qualified name of the database.
        :param str schema_name: The fully qualified name of the schema.
        """
        if all_schemas_in_database is not None:
            pulumi.set(__self__, "all_schemas_in_database", all_schemas_in_database)
        if future_schemas_in_database is not None:
            pulumi.set(__self__, "future_schemas_in_database", future_schemas_in_database)
        if schema_name is not None:
            pulumi.set(__self__, "schema_name", schema_name)

    @property
    @pulumi.getter(name="allSchemasInDatabase")
    def all_schemas_in_database(self) -> Optional[str]:
        """
        The fully qualified name of the database.
        """
        return pulumi.get(self, "all_schemas_in_database")

    @property
    @pulumi.getter(name="futureSchemasInDatabase")
    def future_schemas_in_database(self) -> Optional[str]:
        """
        The fully qualified name of the database.
        """
        return pulumi.get(self, "future_schemas_in_database")

    @property
    @pulumi.getter(name="schemaName")
    def schema_name(self) -> Optional[str]:
        """
        The fully qualified name of the schema.
        """
        return pulumi.get(self, "schema_name")


@pulumi.output_type
class GrantPrivilegesToDatabaseRoleOnSchemaObject(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "objectName":
            suggest = "object_name"
        elif key == "objectType":
            suggest = "object_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GrantPrivilegesToDatabaseRoleOnSchemaObject. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GrantPrivilegesToDatabaseRoleOnSchemaObject.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GrantPrivilegesToDatabaseRoleOnSchemaObject.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 all: Optional['outputs.GrantPrivilegesToDatabaseRoleOnSchemaObjectAll'] = None,
                 future: Optional['outputs.GrantPrivilegesToDatabaseRoleOnSchemaObjectFuture'] = None,
                 object_name: Optional[str] = None,
                 object_type: Optional[str] = None):
        """
        :param 'GrantPrivilegesToDatabaseRoleOnSchemaObjectAllArgs' all: Configures the privilege to be granted on all objects in either a database or schema.
        :param 'GrantPrivilegesToDatabaseRoleOnSchemaObjectFutureArgs' future: Configures the privilege to be granted on future objects in either a database or schema.
        :param str object_name: The fully qualified name of the object on which privileges will be granted.
        :param str object_type: The object type of the schema object on which privileges will be granted. Valid values are: AGGREGATION POLICY | ALERT | AUTHENTICATION POLICY | DATA METRIC FUNCTION | DYNAMIC TABLE | EVENT TABLE | EXTERNAL TABLE | FILE FORMAT | FUNCTION | GIT REPOSITORY | HYBRID TABLE | IMAGE REPOSITORY | ICEBERG TABLE | MASKING POLICY | MATERIALIZED VIEW | MODEL | NETWORK RULE | PACKAGES POLICY | PASSWORD POLICY | PIPE | PROCEDURE | PROJECTION POLICY | ROW ACCESS POLICY | SECRET | SERVICE | SESSION POLICY | SEQUENCE | STAGE | STREAM | TABLE | TAG | TASK | VIEW | STREAMLIT
        """
        if all is not None:
            pulumi.set(__self__, "all", all)
        if future is not None:
            pulumi.set(__self__, "future", future)
        if object_name is not None:
            pulumi.set(__self__, "object_name", object_name)
        if object_type is not None:
            pulumi.set(__self__, "object_type", object_type)

    @property
    @pulumi.getter
    def all(self) -> Optional['outputs.GrantPrivilegesToDatabaseRoleOnSchemaObjectAll']:
        """
        Configures the privilege to be granted on all objects in either a database or schema.
        """
        return pulumi.get(self, "all")

    @property
    @pulumi.getter
    def future(self) -> Optional['outputs.GrantPrivilegesToDatabaseRoleOnSchemaObjectFuture']:
        """
        Configures the privilege to be granted on future objects in either a database or schema.
        """
        return pulumi.get(self, "future")

    @property
    @pulumi.getter(name="objectName")
    def object_name(self) -> Optional[str]:
        """
        The fully qualified name of the object on which privileges will be granted.
        """
        return pulumi.get(self, "object_name")

    @property
    @pulumi.getter(name="objectType")
    def object_type(self) -> Optional[str]:
        """
        The object type of the schema object on which privileges will be granted. Valid values are: AGGREGATION POLICY | ALERT | AUTHENTICATION POLICY | DATA METRIC FUNCTION | DYNAMIC TABLE | EVENT TABLE | EXTERNAL TABLE | FILE FORMAT | FUNCTION | GIT REPOSITORY | HYBRID TABLE | IMAGE REPOSITORY | ICEBERG TABLE | MASKING POLICY | MATERIALIZED VIEW | MODEL | NETWORK RULE | PACKAGES POLICY | PASSWORD POLICY | PIPE | PROCEDURE | PROJECTION POLICY | ROW ACCESS POLICY | SECRET | SERVICE | SESSION POLICY | SEQUENCE | STAGE | STREAM | TABLE | TAG | TASK | VIEW | STREAMLIT
        """
        return pulumi.get(self, "object_type")


@pulumi.output_type
class GrantPrivilegesToDatabaseRoleOnSchemaObjectAll(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "objectTypePlural":
            suggest = "object_type_plural"
        elif key == "inDatabase":
            suggest = "in_database"
        elif key == "inSchema":
            suggest = "in_schema"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GrantPrivilegesToDatabaseRoleOnSchemaObjectAll. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GrantPrivilegesToDatabaseRoleOnSchemaObjectAll.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GrantPrivilegesToDatabaseRoleOnSchemaObjectAll.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 object_type_plural: str,
                 in_database: Optional[str] = None,
                 in_schema: Optional[str] = None):
        """
        :param str object_type_plural: The plural object type of the schema object on which privileges will be granted. Valid values are: AGGREGATION POLICIES | ALERTS | AUTHENTICATION POLICIES | DATA METRIC FUNCTIONS | DYNAMIC TABLES | EVENT TABLES | EXTERNAL TABLES | FILE FORMATS | FUNCTIONS | GIT REPOSITORIES | HYBRID TABLES | IMAGE REPOSITORIES | ICEBERG TABLES | MASKING POLICIES | MATERIALIZED VIEWS | MODELS | NETWORK RULES | PACKAGES POLICIES | PASSWORD POLICIES | PIPES | PROCEDURES | PROJECTION POLICIES | ROW ACCESS POLICIES | SECRETS | SERVICES | SESSION POLICIES | SEQUENCES | STAGES | STREAMS | TABLES | TAGS | TASKS | VIEWS | STREAMLITS.
        :param str in_database: The fully qualified name of the database.
        :param str in_schema: The fully qualified name of the schema.
        """
        pulumi.set(__self__, "object_type_plural", object_type_plural)
        if in_database is not None:
            pulumi.set(__self__, "in_database", in_database)
        if in_schema is not None:
            pulumi.set(__self__, "in_schema", in_schema)

    @property
    @pulumi.getter(name="objectTypePlural")
    def object_type_plural(self) -> str:
        """
        The plural object type of the schema object on which privileges will be granted. Valid values are: AGGREGATION POLICIES | ALERTS | AUTHENTICATION POLICIES | DATA METRIC FUNCTIONS | DYNAMIC TABLES | EVENT TABLES | EXTERNAL TABLES | FILE FORMATS | FUNCTIONS | GIT REPOSITORIES | HYBRID TABLES | IMAGE REPOSITORIES | ICEBERG TABLES | MASKING POLICIES | MATERIALIZED VIEWS | MODELS | NETWORK RULES | PACKAGES POLICIES | PASSWORD POLICIES | PIPES | PROCEDURES | PROJECTION POLICIES | ROW ACCESS POLICIES | SECRETS | SERVICES | SESSION POLICIES | SEQUENCES | STAGES | STREAMS | TABLES | TAGS | TASKS | VIEWS | STREAMLITS.
        """
        return pulumi.get(self, "object_type_plural")

    @property
    @pulumi.getter(name="inDatabase")
    def in_database(self) -> Optional[str]:
        """
        The fully qualified name of the database.
        """
        return pulumi.get(self, "in_database")

    @property
    @pulumi.getter(name="inSchema")
    def in_schema(self) -> Optional[str]:
        """
        The fully qualified name of the schema.
        """
        return pulumi.get(self, "in_schema")


@pulumi.output_type
class GrantPrivilegesToDatabaseRoleOnSchemaObjectFuture(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "objectTypePlural":
            suggest = "object_type_plural"
        elif key == "inDatabase":
            suggest = "in_database"
        elif key == "inSchema":
            suggest = "in_schema"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GrantPrivilegesToDatabaseRoleOnSchemaObjectFuture. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GrantPrivilegesToDatabaseRoleOnSchemaObjectFuture.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GrantPrivilegesToDatabaseRoleOnSchemaObjectFuture.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 object_type_plural: str,
                 in_database: Optional[str] = None,
                 in_schema: Optional[str] = None):
        """
        :param str object_type_plural: The plural object type of the schema object on which privileges will be granted. Valid values are: ALERTS | AUTHENTICATION POLICIES | DATA METRIC FUNCTIONS | DYNAMIC TABLES | EVENT TABLES | EXTERNAL TABLES | FILE FORMATS | FUNCTIONS | GIT REPOSITORIES | HYBRID TABLES | ICEBERG TABLES | MATERIALIZED VIEWS | MODELS | NETWORK RULES | PASSWORD POLICIES | PIPES | PROCEDURES | SECRETS | SERVICES | SEQUENCES | STAGES | STREAMS | TABLES | TASKS | VIEWS.
        :param str in_database: The fully qualified name of the database.
        :param str in_schema: The fully qualified name of the schema.
        """
        pulumi.set(__self__, "object_type_plural", object_type_plural)
        if in_database is not None:
            pulumi.set(__self__, "in_database", in_database)
        if in_schema is not None:
            pulumi.set(__self__, "in_schema", in_schema)

    @property
    @pulumi.getter(name="objectTypePlural")
    def object_type_plural(self) -> str:
        """
        The plural object type of the schema object on which privileges will be granted. Valid values are: ALERTS | AUTHENTICATION POLICIES | DATA METRIC FUNCTIONS | DYNAMIC TABLES | EVENT TABLES | EXTERNAL TABLES | FILE FORMATS | FUNCTIONS | GIT REPOSITORIES | HYBRID TABLES | ICEBERG TABLES | MATERIALIZED VIEWS | MODELS | NETWORK RULES | PASSWORD POLICIES | PIPES | PROCEDURES | SECRETS | SERVICES | SEQUENCES | STAGES | STREAMS | TABLES | TASKS | VIEWS.
        """
        return pulumi.get(self, "object_type_plural")

    @property
    @pulumi.getter(name="inDatabase")
    def in_database(self) -> Optional[str]:
        """
        The fully qualified name of the database.
        """
        return pulumi.get(self, "in_database")

    @property
    @pulumi.getter(name="inSchema")
    def in_schema(self) -> Optional[str]:
        """
        The fully qualified name of the schema.
        """
        return pulumi.get(self, "in_schema")


@pulumi.output_type
class GrantPrivilegesToRoleOnAccountObject(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "objectName":
            suggest = "object_name"
        elif key == "objectType":
            suggest = "object_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GrantPrivilegesToRoleOnAccountObject. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GrantPrivilegesToRoleOnAccountObject.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GrantPrivilegesToRoleOnAccountObject.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 object_name: str,
                 object_type: str):
        """
        :param str object_name: The fully qualified name of the object on which privileges will be granted.
        :param str object_type: The object type of the account object on which privileges will be granted. Valid values are: USER | RESOURCE MONITOR | WAREHOUSE | DATABASE | INTEGRATION | FAILOVER GROUP | REPLICATION GROUP | EXTERNAL VOLUME
        """
        pulumi.set(__self__, "object_name", object_name)
        pulumi.set(__self__, "object_type", object_type)

    @property
    @pulumi.getter(name="objectName")
    def object_name(self) -> str:
        """
        The fully qualified name of the object on which privileges will be granted.
        """
        return pulumi.get(self, "object_name")

    @property
    @pulumi.getter(name="objectType")
    def object_type(self) -> str:
        """
        The object type of the account object on which privileges will be granted. Valid values are: USER | RESOURCE MONITOR | WAREHOUSE | DATABASE | INTEGRATION | FAILOVER GROUP | REPLICATION GROUP | EXTERNAL VOLUME
        """
        return pulumi.get(self, "object_type")


@pulumi.output_type
class GrantPrivilegesToRoleOnSchema(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "allSchemasInDatabase":
            suggest = "all_schemas_in_database"
        elif key == "futureSchemasInDatabase":
            suggest = "future_schemas_in_database"
        elif key == "schemaName":
            suggest = "schema_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GrantPrivilegesToRoleOnSchema. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GrantPrivilegesToRoleOnSchema.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GrantPrivilegesToRoleOnSchema.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 all_schemas_in_database: Optional[str] = None,
                 future_schemas_in_database: Optional[str] = None,
                 schema_name: Optional[str] = None):
        """
        :param str all_schemas_in_database: The fully qualified name of the database.
        :param str future_schemas_in_database: The fully qualified name of the database.
        :param str schema_name: The fully qualified name of the schema.
        """
        if all_schemas_in_database is not None:
            pulumi.set(__self__, "all_schemas_in_database", all_schemas_in_database)
        if future_schemas_in_database is not None:
            pulumi.set(__self__, "future_schemas_in_database", future_schemas_in_database)
        if schema_name is not None:
            pulumi.set(__self__, "schema_name", schema_name)

    @property
    @pulumi.getter(name="allSchemasInDatabase")
    def all_schemas_in_database(self) -> Optional[str]:
        """
        The fully qualified name of the database.
        """
        return pulumi.get(self, "all_schemas_in_database")

    @property
    @pulumi.getter(name="futureSchemasInDatabase")
    def future_schemas_in_database(self) -> Optional[str]:
        """
        The fully qualified name of the database.
        """
        return pulumi.get(self, "future_schemas_in_database")

    @property
    @pulumi.getter(name="schemaName")
    def schema_name(self) -> Optional[str]:
        """
        The fully qualified name of the schema.
        """
        return pulumi.get(self, "schema_name")


@pulumi.output_type
class GrantPrivilegesToRoleOnSchemaObject(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "objectName":
            suggest = "object_name"
        elif key == "objectType":
            suggest = "object_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GrantPrivilegesToRoleOnSchemaObject. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GrantPrivilegesToRoleOnSchemaObject.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GrantPrivilegesToRoleOnSchemaObject.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 all: Optional['outputs.GrantPrivilegesToRoleOnSchemaObjectAll'] = None,
                 future: Optional['outputs.GrantPrivilegesToRoleOnSchemaObjectFuture'] = None,
                 object_name: Optional[str] = None,
                 object_type: Optional[str] = None):
        """
        :param 'GrantPrivilegesToRoleOnSchemaObjectAllArgs' all: Configures the privilege to be granted on all objects in eihter a database or schema.
        :param 'GrantPrivilegesToRoleOnSchemaObjectFutureArgs' future: Configures the privilege to be granted on future objects in eihter a database or schema.
        :param str object_name: The fully qualified name of the object on which privileges will be granted.
        :param str object_type: The object type of the schema object on which privileges will be granted. Valid values are: AGGREGATION POLICY | ALERT | AUTHENTICATION POLICY | DATA METRIC FUNCTION | DYNAMIC TABLE | EVENT TABLE | EXTERNAL TABLE | FILE FORMAT | FUNCTION | GIT REPOSITORY | HYBRID TABLE | IMAGE REPOSITORY | ICEBERG TABLE | MASKING POLICY | MATERIALIZED VIEW | MODEL | NETWORK RULE | PACKAGES POLICY | PASSWORD POLICY | PIPE | PROCEDURE | PROJECTION POLICY | ROW ACCESS POLICY | SECRET | SERVICE | SESSION POLICY | SEQUENCE | STAGE | STREAM | TABLE | TAG | TASK | VIEW | STREAMLIT
        """
        if all is not None:
            pulumi.set(__self__, "all", all)
        if future is not None:
            pulumi.set(__self__, "future", future)
        if object_name is not None:
            pulumi.set(__self__, "object_name", object_name)
        if object_type is not None:
            pulumi.set(__self__, "object_type", object_type)

    @property
    @pulumi.getter
    def all(self) -> Optional['outputs.GrantPrivilegesToRoleOnSchemaObjectAll']:
        """
        Configures the privilege to be granted on all objects in eihter a database or schema.
        """
        return pulumi.get(self, "all")

    @property
    @pulumi.getter
    def future(self) -> Optional['outputs.GrantPrivilegesToRoleOnSchemaObjectFuture']:
        """
        Configures the privilege to be granted on future objects in eihter a database or schema.
        """
        return pulumi.get(self, "future")

    @property
    @pulumi.getter(name="objectName")
    def object_name(self) -> Optional[str]:
        """
        The fully qualified name of the object on which privileges will be granted.
        """
        return pulumi.get(self, "object_name")

    @property
    @pulumi.getter(name="objectType")
    def object_type(self) -> Optional[str]:
        """
        The object type of the schema object on which privileges will be granted. Valid values are: AGGREGATION POLICY | ALERT | AUTHENTICATION POLICY | DATA METRIC FUNCTION | DYNAMIC TABLE | EVENT TABLE | EXTERNAL TABLE | FILE FORMAT | FUNCTION | GIT REPOSITORY | HYBRID TABLE | IMAGE REPOSITORY | ICEBERG TABLE | MASKING POLICY | MATERIALIZED VIEW | MODEL | NETWORK RULE | PACKAGES POLICY | PASSWORD POLICY | PIPE | PROCEDURE | PROJECTION POLICY | ROW ACCESS POLICY | SECRET | SERVICE | SESSION POLICY | SEQUENCE | STAGE | STREAM | TABLE | TAG | TASK | VIEW | STREAMLIT
        """
        return pulumi.get(self, "object_type")


@pulumi.output_type
class GrantPrivilegesToRoleOnSchemaObjectAll(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "objectTypePlural":
            suggest = "object_type_plural"
        elif key == "inDatabase":
            suggest = "in_database"
        elif key == "inSchema":
            suggest = "in_schema"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GrantPrivilegesToRoleOnSchemaObjectAll. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GrantPrivilegesToRoleOnSchemaObjectAll.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GrantPrivilegesToRoleOnSchemaObjectAll.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 object_type_plural: str,
                 in_database: Optional[str] = None,
                 in_schema: Optional[str] = None):
        """
        :param str object_type_plural: The plural object type of the schema object on which privileges will be granted. Valid values are: AGGREGATION POLICIES | ALERTS | AUTHENTICATION POLICIES | DATA METRIC FUNCTIONS | DYNAMIC TABLES | EVENT TABLES | EXTERNAL TABLES | FILE FORMATS | FUNCTIONS | GIT REPOSITORIES | HYBRID TABLES | IMAGE REPOSITORIES | ICEBERG TABLES | MASKING POLICIES | MATERIALIZED VIEWS | MODELS | NETWORK RULES | PACKAGES POLICIES | PASSWORD POLICIES | PIPES | PROCEDURES | PROJECTION POLICIES | ROW ACCESS POLICIES | SECRETS | SERVICES | SESSION POLICIES | SEQUENCES | STAGES | STREAMS | TABLES | TAGS | TASKS | VIEWS | STREAMLITS
        :param str in_database: The fully qualified name of the database.
        :param str in_schema: The fully qualified name of the schema.
        """
        pulumi.set(__self__, "object_type_plural", object_type_plural)
        if in_database is not None:
            pulumi.set(__self__, "in_database", in_database)
        if in_schema is not None:
            pulumi.set(__self__, "in_schema", in_schema)

    @property
    @pulumi.getter(name="objectTypePlural")
    def object_type_plural(self) -> str:
        """
        The plural object type of the schema object on which privileges will be granted. Valid values are: AGGREGATION POLICIES | ALERTS | AUTHENTICATION POLICIES | DATA METRIC FUNCTIONS | DYNAMIC TABLES | EVENT TABLES | EXTERNAL TABLES | FILE FORMATS | FUNCTIONS | GIT REPOSITORIES | HYBRID TABLES | IMAGE REPOSITORIES | ICEBERG TABLES | MASKING POLICIES | MATERIALIZED VIEWS | MODELS | NETWORK RULES | PACKAGES POLICIES | PASSWORD POLICIES | PIPES | PROCEDURES | PROJECTION POLICIES | ROW ACCESS POLICIES | SECRETS | SERVICES | SESSION POLICIES | SEQUENCES | STAGES | STREAMS | TABLES | TAGS | TASKS | VIEWS | STREAMLITS
        """
        return pulumi.get(self, "object_type_plural")

    @property
    @pulumi.getter(name="inDatabase")
    def in_database(self) -> Optional[str]:
        """
        The fully qualified name of the database.
        """
        return pulumi.get(self, "in_database")

    @property
    @pulumi.getter(name="inSchema")
    def in_schema(self) -> Optional[str]:
        """
        The fully qualified name of the schema.
        """
        return pulumi.get(self, "in_schema")


@pulumi.output_type
class GrantPrivilegesToRoleOnSchemaObjectFuture(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "objectTypePlural":
            suggest = "object_type_plural"
        elif key == "inDatabase":
            suggest = "in_database"
        elif key == "inSchema":
            suggest = "in_schema"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GrantPrivilegesToRoleOnSchemaObjectFuture. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GrantPrivilegesToRoleOnSchemaObjectFuture.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GrantPrivilegesToRoleOnSchemaObjectFuture.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 object_type_plural: str,
                 in_database: Optional[str] = None,
                 in_schema: Optional[str] = None):
        """
        :param str object_type_plural: The plural object type of the schema object on which privileges will be granted. Valid values are: ALERTS | AUTHENTICATION POLICIES | DATA METRIC FUNCTIONS | DYNAMIC TABLES | EVENT TABLES | EXTERNAL TABLES | FILE FORMATS | FUNCTIONS | GIT REPOSITORIES | HYBRID TABLES | ICEBERG TABLES | MATERIALIZED VIEWS | MODELS | NETWORK RULES | PASSWORD POLICIES | PIPES | PROCEDURES | SECRETS | SERVICES | SEQUENCES | STAGES | STREAMS | TABLES | TASKS | VIEWS
        :param str in_database: The fully qualified name of the database.
        :param str in_schema: The fully qualified name of the schema.
        """
        pulumi.set(__self__, "object_type_plural", object_type_plural)
        if in_database is not None:
            pulumi.set(__self__, "in_database", in_database)
        if in_schema is not None:
            pulumi.set(__self__, "in_schema", in_schema)

    @property
    @pulumi.getter(name="objectTypePlural")
    def object_type_plural(self) -> str:
        """
        The plural object type of the schema object on which privileges will be granted. Valid values are: ALERTS | AUTHENTICATION POLICIES | DATA METRIC FUNCTIONS | DYNAMIC TABLES | EVENT TABLES | EXTERNAL TABLES | FILE FORMATS | FUNCTIONS | GIT REPOSITORIES | HYBRID TABLES | ICEBERG TABLES | MATERIALIZED VIEWS | MODELS | NETWORK RULES | PASSWORD POLICIES | PIPES | PROCEDURES | SECRETS | SERVICES | SEQUENCES | STAGES | STREAMS | TABLES | TASKS | VIEWS
        """
        return pulumi.get(self, "object_type_plural")

    @property
    @pulumi.getter(name="inDatabase")
    def in_database(self) -> Optional[str]:
        """
        The fully qualified name of the database.
        """
        return pulumi.get(self, "in_database")

    @property
    @pulumi.getter(name="inSchema")
    def in_schema(self) -> Optional[str]:
        """
        The fully qualified name of the schema.
        """
        return pulumi.get(self, "in_schema")


@pulumi.output_type
class MaskingPolicySignature(dict):
    def __init__(__self__, *,
                 columns: Sequence['outputs.MaskingPolicySignatureColumn']):
        pulumi.set(__self__, "columns", columns)

    @property
    @pulumi.getter
    def columns(self) -> Sequence['outputs.MaskingPolicySignatureColumn']:
        return pulumi.get(self, "columns")


@pulumi.output_type
class MaskingPolicySignatureColumn(dict):
    def __init__(__self__, *,
                 name: str,
                 type: str):
        """
        :param str name: Specifies the column name to mask.
        :param str type: Specifies the column type to mask.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Specifies the column name to mask.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Specifies the column type to mask.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class MaterializedViewTag(dict):
    def __init__(__self__, *,
                 name: str,
                 value: str,
                 database: Optional[str] = None,
                 schema: Optional[str] = None):
        """
        :param str name: Tag name, e.g. department.
        :param str value: Tag value, e.g. marketing_info.
        :param str database: Name of the database that the tag was created in.
        :param str schema: Name of the schema that the tag was created in.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "value", value)
        if database is not None:
            pulumi.set(__self__, "database", database)
        if schema is not None:
            pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Tag name, e.g. department.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Tag value, e.g. marketing_info.
        """
        return pulumi.get(self, "value")

    @property
    @pulumi.getter
    def database(self) -> Optional[str]:
        """
        Name of the database that the tag was created in.
        """
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def schema(self) -> Optional[str]:
        """
        Name of the schema that the tag was created in.
        """
        return pulumi.get(self, "schema")


@pulumi.output_type
class ObjectParameterObjectIdentifier(dict):
    def __init__(__self__, *,
                 name: str,
                 database: Optional[str] = None,
                 schema: Optional[str] = None):
        """
        :param str name: Name of the object to set the parameter for.
        :param str database: Name of the database that the object was created in.
        :param str schema: Name of the schema that the object was created in.
        """
        pulumi.set(__self__, "name", name)
        if database is not None:
            pulumi.set(__self__, "database", database)
        if schema is not None:
            pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of the object to set the parameter for.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def database(self) -> Optional[str]:
        """
        Name of the database that the object was created in.
        """
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def schema(self) -> Optional[str]:
        """
        Name of the schema that the object was created in.
        """
        return pulumi.get(self, "schema")


@pulumi.output_type
class ProcedureArgument(dict):
    def __init__(__self__, *,
                 name: str,
                 type: str):
        """
        :param str name: The argument name
        :param str type: The argument type
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The argument name
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The argument type
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class RoleTag(dict):
    def __init__(__self__, *,
                 name: str,
                 value: str,
                 database: Optional[str] = None,
                 schema: Optional[str] = None):
        """
        :param str name: Tag name, e.g. department.
        :param str value: Tag value, e.g. marketing_info.
        :param str database: Name of the database that the tag was created in.
        :param str schema: Name of the schema that the tag was created in.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "value", value)
        if database is not None:
            pulumi.set(__self__, "database", database)
        if schema is not None:
            pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Tag name, e.g. department.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Tag value, e.g. marketing_info.
        """
        return pulumi.get(self, "value")

    @property
    @pulumi.getter
    def database(self) -> Optional[str]:
        """
        Name of the database that the tag was created in.
        """
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def schema(self) -> Optional[str]:
        """
        Name of the schema that the tag was created in.
        """
        return pulumi.get(self, "schema")


@pulumi.output_type
class SchemaTag(dict):
    def __init__(__self__, *,
                 name: str,
                 value: str,
                 database: Optional[str] = None,
                 schema: Optional[str] = None):
        """
        :param str name: Tag name, e.g. department.
        :param str value: Tag value, e.g. marketing_info.
        :param str database: Name of the database that the tag was created in.
        :param str schema: Name of the schema that the tag was created in.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "value", value)
        if database is not None:
            pulumi.set(__self__, "database", database)
        if schema is not None:
            pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Tag name, e.g. department.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Tag value, e.g. marketing_info.
        """
        return pulumi.get(self, "value")

    @property
    @pulumi.getter
    def database(self) -> Optional[str]:
        """
        Name of the database that the tag was created in.
        """
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def schema(self) -> Optional[str]:
        """
        Name of the schema that the tag was created in.
        """
        return pulumi.get(self, "schema")


@pulumi.output_type
class StageTag(dict):
    def __init__(__self__, *,
                 name: str,
                 value: str,
                 database: Optional[str] = None,
                 schema: Optional[str] = None):
        """
        :param str name: Tag name, e.g. department.
        :param str value: Tag value, e.g. marketing_info.
        :param str database: Name of the database that the tag was created in.
        :param str schema: Name of the schema that the tag was created in.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "value", value)
        if database is not None:
            pulumi.set(__self__, "database", database)
        if schema is not None:
            pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Tag name, e.g. department.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Tag value, e.g. marketing_info.
        """
        return pulumi.get(self, "value")

    @property
    @pulumi.getter
    def database(self) -> Optional[str]:
        """
        Name of the database that the tag was created in.
        """
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def schema(self) -> Optional[str]:
        """
        Name of the schema that the tag was created in.
        """
        return pulumi.get(self, "schema")


@pulumi.output_type
class TableColumn(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "maskingPolicy":
            suggest = "masking_policy"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in TableColumn. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        TableColumn.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        TableColumn.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 name: str,
                 type: str,
                 collate: Optional[str] = None,
                 comment: Optional[str] = None,
                 default: Optional['outputs.TableColumnDefault'] = None,
                 identity: Optional['outputs.TableColumnIdentity'] = None,
                 masking_policy: Optional[str] = None,
                 nullable: Optional[bool] = None):
        """
        :param str name: Column name
        :param str type: Column type, e.g. VARIANT
        :param str collate: Column collation, e.g. utf8
        :param str comment: Column comment
        :param 'TableColumnDefaultArgs' default: Defines the column default value; note due to limitations of Snowflake's ALTER TABLE ADD/MODIFY COLUMN updates to default will not be applied
        :param 'TableColumnIdentityArgs' identity: Defines the identity start/step values for a column. **Note** Identity/default are mutually exclusive.
        :param str masking_policy: Masking policy to apply on column. It has to be a fully qualified name.
        :param bool nullable: Whether this column can contain null values. **Note**: Depending on your Snowflake version, the default value will not suffice if this column is used in a primary key constraint.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "type", type)
        if collate is not None:
            pulumi.set(__self__, "collate", collate)
        if comment is not None:
            pulumi.set(__self__, "comment", comment)
        if default is not None:
            pulumi.set(__self__, "default", default)
        if identity is not None:
            pulumi.set(__self__, "identity", identity)
        if masking_policy is not None:
            pulumi.set(__self__, "masking_policy", masking_policy)
        if nullable is not None:
            pulumi.set(__self__, "nullable", nullable)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Column name
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Column type, e.g. VARIANT
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def collate(self) -> Optional[str]:
        """
        Column collation, e.g. utf8
        """
        return pulumi.get(self, "collate")

    @property
    @pulumi.getter
    def comment(self) -> Optional[str]:
        """
        Column comment
        """
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def default(self) -> Optional['outputs.TableColumnDefault']:
        """
        Defines the column default value; note due to limitations of Snowflake's ALTER TABLE ADD/MODIFY COLUMN updates to default will not be applied
        """
        return pulumi.get(self, "default")

    @property
    @pulumi.getter
    def identity(self) -> Optional['outputs.TableColumnIdentity']:
        """
        Defines the identity start/step values for a column. **Note** Identity/default are mutually exclusive.
        """
        return pulumi.get(self, "identity")

    @property
    @pulumi.getter(name="maskingPolicy")
    def masking_policy(self) -> Optional[str]:
        """
        Masking policy to apply on column. It has to be a fully qualified name.
        """
        return pulumi.get(self, "masking_policy")

    @property
    @pulumi.getter
    def nullable(self) -> Optional[bool]:
        """
        Whether this column can contain null values. **Note**: Depending on your Snowflake version, the default value will not suffice if this column is used in a primary key constraint.
        """
        return pulumi.get(self, "nullable")


@pulumi.output_type
class TableColumnDefault(dict):
    def __init__(__self__, *,
                 constant: Optional[str] = None,
                 expression: Optional[str] = None,
                 sequence: Optional[str] = None):
        """
        :param str constant: The default constant value for the column
        :param str expression: The default expression value for the column
        :param str sequence: The default sequence to use for the column
        """
        if constant is not None:
            pulumi.set(__self__, "constant", constant)
        if expression is not None:
            pulumi.set(__self__, "expression", expression)
        if sequence is not None:
            pulumi.set(__self__, "sequence", sequence)

    @property
    @pulumi.getter
    def constant(self) -> Optional[str]:
        """
        The default constant value for the column
        """
        return pulumi.get(self, "constant")

    @property
    @pulumi.getter
    def expression(self) -> Optional[str]:
        """
        The default expression value for the column
        """
        return pulumi.get(self, "expression")

    @property
    @pulumi.getter
    def sequence(self) -> Optional[str]:
        """
        The default sequence to use for the column
        """
        return pulumi.get(self, "sequence")


@pulumi.output_type
class TableColumnIdentity(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "startNum":
            suggest = "start_num"
        elif key == "stepNum":
            suggest = "step_num"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in TableColumnIdentity. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        TableColumnIdentity.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        TableColumnIdentity.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 start_num: Optional[int] = None,
                 step_num: Optional[int] = None):
        """
        :param int start_num: The number to start incrementing at.
        :param int step_num: Step size to increment by.
        """
        if start_num is not None:
            pulumi.set(__self__, "start_num", start_num)
        if step_num is not None:
            pulumi.set(__self__, "step_num", step_num)

    @property
    @pulumi.getter(name="startNum")
    def start_num(self) -> Optional[int]:
        """
        The number to start incrementing at.
        """
        return pulumi.get(self, "start_num")

    @property
    @pulumi.getter(name="stepNum")
    def step_num(self) -> Optional[int]:
        """
        Step size to increment by.
        """
        return pulumi.get(self, "step_num")


@pulumi.output_type
class TableConstraintForeignKeyProperties(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "onDelete":
            suggest = "on_delete"
        elif key == "onUpdate":
            suggest = "on_update"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in TableConstraintForeignKeyProperties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        TableConstraintForeignKeyProperties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        TableConstraintForeignKeyProperties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 match: Optional[str] = None,
                 on_delete: Optional[str] = None,
                 on_update: Optional[str] = None,
                 references: Optional['outputs.TableConstraintForeignKeyPropertiesReferences'] = None):
        """
        :param str match: The match type for the foreign key. Not applicable for primary/unique keys
        :param str on_delete: Specifies the action performed when the primary/unique key for the foreign key is deleted. Not applicable for primary/unique keys
        :param str on_update: Specifies the action performed when the primary/unique key for the foreign key is updated. Not applicable for primary/unique keys
        :param 'TableConstraintForeignKeyPropertiesReferencesArgs' references: The table and columns that the foreign key references. Not applicable for primary/unique keys
        """
        if match is not None:
            pulumi.set(__self__, "match", match)
        if on_delete is not None:
            pulumi.set(__self__, "on_delete", on_delete)
        if on_update is not None:
            pulumi.set(__self__, "on_update", on_update)
        if references is not None:
            pulumi.set(__self__, "references", references)

    @property
    @pulumi.getter
    def match(self) -> Optional[str]:
        """
        The match type for the foreign key. Not applicable for primary/unique keys
        """
        return pulumi.get(self, "match")

    @property
    @pulumi.getter(name="onDelete")
    def on_delete(self) -> Optional[str]:
        """
        Specifies the action performed when the primary/unique key for the foreign key is deleted. Not applicable for primary/unique keys
        """
        return pulumi.get(self, "on_delete")

    @property
    @pulumi.getter(name="onUpdate")
    def on_update(self) -> Optional[str]:
        """
        Specifies the action performed when the primary/unique key for the foreign key is updated. Not applicable for primary/unique keys
        """
        return pulumi.get(self, "on_update")

    @property
    @pulumi.getter
    def references(self) -> Optional['outputs.TableConstraintForeignKeyPropertiesReferences']:
        """
        The table and columns that the foreign key references. Not applicable for primary/unique keys
        """
        return pulumi.get(self, "references")


@pulumi.output_type
class TableConstraintForeignKeyPropertiesReferences(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "tableId":
            suggest = "table_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in TableConstraintForeignKeyPropertiesReferences. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        TableConstraintForeignKeyPropertiesReferences.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        TableConstraintForeignKeyPropertiesReferences.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 columns: Sequence[str],
                 table_id: str):
        """
        :param Sequence[str] columns: Columns to use in foreign key reference
        :param str table_id: Name of constraint
        """
        pulumi.set(__self__, "columns", columns)
        pulumi.set(__self__, "table_id", table_id)

    @property
    @pulumi.getter
    def columns(self) -> Sequence[str]:
        """
        Columns to use in foreign key reference
        """
        return pulumi.get(self, "columns")

    @property
    @pulumi.getter(name="tableId")
    def table_id(self) -> str:
        """
        Name of constraint
        """
        return pulumi.get(self, "table_id")


@pulumi.output_type
class TablePrimaryKey(dict):
    def __init__(__self__, *,
                 keys: Sequence[str],
                 name: Optional[str] = None):
        """
        :param Sequence[str] keys: Columns to use in primary key
        :param str name: Name of constraint
        """
        pulumi.set(__self__, "keys", keys)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def keys(self) -> Sequence[str]:
        """
        Columns to use in primary key
        """
        return pulumi.get(self, "keys")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Name of constraint
        """
        return pulumi.get(self, "name")


@pulumi.output_type
class TableTag(dict):
    def __init__(__self__, *,
                 name: str,
                 value: str,
                 database: Optional[str] = None,
                 schema: Optional[str] = None):
        """
        :param str name: Tag name, e.g. department.
        :param str value: Tag value, e.g. marketing_info.
        :param str database: Name of the database that the tag was created in.
        :param str schema: Name of the schema that the tag was created in.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "value", value)
        if database is not None:
            pulumi.set(__self__, "database", database)
        if schema is not None:
            pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Tag name, e.g. department.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Tag value, e.g. marketing_info.
        """
        return pulumi.get(self, "value")

    @property
    @pulumi.getter
    def database(self) -> Optional[str]:
        """
        Name of the database that the tag was created in.
        """
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def schema(self) -> Optional[str]:
        """
        Name of the schema that the tag was created in.
        """
        return pulumi.get(self, "schema")


@pulumi.output_type
class TagAssociationObjectIdentifier(dict):
    def __init__(__self__, *,
                 name: str,
                 database: Optional[str] = None,
                 schema: Optional[str] = None):
        """
        :param str name: Name of the object to associate the tag with.
        :param str database: Name of the database that the object was created in.
        :param str schema: Name of the schema that the object was created in.
        """
        pulumi.set(__self__, "name", name)
        if database is not None:
            pulumi.set(__self__, "database", database)
        if schema is not None:
            pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of the object to associate the tag with.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def database(self) -> Optional[str]:
        """
        Name of the database that the object was created in.
        """
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def schema(self) -> Optional[str]:
        """
        Name of the schema that the object was created in.
        """
        return pulumi.get(self, "schema")


@pulumi.output_type
class ViewTag(dict):
    def __init__(__self__, *,
                 name: str,
                 value: str,
                 database: Optional[str] = None,
                 schema: Optional[str] = None):
        """
        :param str name: Tag name, e.g. department.
        :param str value: Tag value, e.g. marketing_info.
        :param str database: Name of the database that the tag was created in.
        :param str schema: Name of the schema that the tag was created in.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "value", value)
        if database is not None:
            pulumi.set(__self__, "database", database)
        if schema is not None:
            pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Tag name, e.g. department.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Tag value, e.g. marketing_info.
        """
        return pulumi.get(self, "value")

    @property
    @pulumi.getter
    def database(self) -> Optional[str]:
        """
        Name of the database that the tag was created in.
        """
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def schema(self) -> Optional[str]:
        """
        Name of the schema that the tag was created in.
        """
        return pulumi.get(self, "schema")


@pulumi.output_type
class GetAccountsAccountResult(dict):
    def __init__(__self__, *,
                 account_locator: str,
                 account_locator_url: str,
                 account_name: str,
                 account_url: str,
                 comment: str,
                 consumption_billing_entity_name: str,
                 created_on: str,
                 edition: str,
                 is_org_admin: bool,
                 managed_accounts: int,
                 marketplace_consumer_billing_entity_name: str,
                 marketplace_provider_billing_entity_name: str,
                 old_account_url: str,
                 organization_name: str,
                 region_group: str,
                 snowflake_region: str):
        """
        :param str account_locator: System-assigned identifier of the acccount.
        :param str account_locator_url: Legacy Snowflake access URL syntax that includes the region_name and account_locator.
        :param str account_name: User-defined name that identifies an account within the organization.
        :param str account_url: Preferred Snowflake access URL that includes the values of organization_name and account_name.
        :param str comment: Comment for the account.
        :param str consumption_billing_entity_name: Name of the consumption billing entity.
        :param str created_on: Date and time when the account was created.
        :param str edition: Snowflake Edition of the account.
        :param bool is_org_admin: Indicates whether the ORGADMIN role is enabled in an account. If TRUE, the role is enabled.
        :param int managed_accounts: Indicates how many managed accounts have been created by the account.
        :param str marketplace_consumer_billing_entity_name: Name of the marketplace consumer billing entity.
        :param str marketplace_provider_billing_entity_name: Name of the marketplace provider billing entity.
        :param str old_account_url: The previous account URL for a given account.
        :param str organization_name: Name of the organization.
        :param str region_group: Region group where the account is located. Note: this column is only visible to organizations that span multiple Region Groups.
        :param str snowflake_region: Snowflake Region where the account is located. A Snowflake Region is a distinct location within a cloud platform region that is isolated from other Snowflake Regions. A Snowflake Region can be either multi-tenant or single-tenant (for a Virtual Private Snowflake account).
        """
        pulumi.set(__self__, "account_locator", account_locator)
        pulumi.set(__self__, "account_locator_url", account_locator_url)
        pulumi.set(__self__, "account_name", account_name)
        pulumi.set(__self__, "account_url", account_url)
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "consumption_billing_entity_name", consumption_billing_entity_name)
        pulumi.set(__self__, "created_on", created_on)
        pulumi.set(__self__, "edition", edition)
        pulumi.set(__self__, "is_org_admin", is_org_admin)
        pulumi.set(__self__, "managed_accounts", managed_accounts)
        pulumi.set(__self__, "marketplace_consumer_billing_entity_name", marketplace_consumer_billing_entity_name)
        pulumi.set(__self__, "marketplace_provider_billing_entity_name", marketplace_provider_billing_entity_name)
        pulumi.set(__self__, "old_account_url", old_account_url)
        pulumi.set(__self__, "organization_name", organization_name)
        pulumi.set(__self__, "region_group", region_group)
        pulumi.set(__self__, "snowflake_region", snowflake_region)

    @property
    @pulumi.getter(name="accountLocator")
    def account_locator(self) -> str:
        """
        System-assigned identifier of the acccount.
        """
        return pulumi.get(self, "account_locator")

    @property
    @pulumi.getter(name="accountLocatorUrl")
    def account_locator_url(self) -> str:
        """
        Legacy Snowflake access URL syntax that includes the region_name and account_locator.
        """
        return pulumi.get(self, "account_locator_url")

    @property
    @pulumi.getter(name="accountName")
    def account_name(self) -> str:
        """
        User-defined name that identifies an account within the organization.
        """
        return pulumi.get(self, "account_name")

    @property
    @pulumi.getter(name="accountUrl")
    def account_url(self) -> str:
        """
        Preferred Snowflake access URL that includes the values of organization_name and account_name.
        """
        return pulumi.get(self, "account_url")

    @property
    @pulumi.getter
    def comment(self) -> str:
        """
        Comment for the account.
        """
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter(name="consumptionBillingEntityName")
    def consumption_billing_entity_name(self) -> str:
        """
        Name of the consumption billing entity.
        """
        return pulumi.get(self, "consumption_billing_entity_name")

    @property
    @pulumi.getter(name="createdOn")
    def created_on(self) -> str:
        """
        Date and time when the account was created.
        """
        return pulumi.get(self, "created_on")

    @property
    @pulumi.getter
    def edition(self) -> str:
        """
        Snowflake Edition of the account.
        """
        return pulumi.get(self, "edition")

    @property
    @pulumi.getter(name="isOrgAdmin")
    def is_org_admin(self) -> bool:
        """
        Indicates whether the ORGADMIN role is enabled in an account. If TRUE, the role is enabled.
        """
        return pulumi.get(self, "is_org_admin")

    @property
    @pulumi.getter(name="managedAccounts")
    def managed_accounts(self) -> int:
        """
        Indicates how many managed accounts have been created by the account.
        """
        return pulumi.get(self, "managed_accounts")

    @property
    @pulumi.getter(name="marketplaceConsumerBillingEntityName")
    def marketplace_consumer_billing_entity_name(self) -> str:
        """
        Name of the marketplace consumer billing entity.
        """
        return pulumi.get(self, "marketplace_consumer_billing_entity_name")

    @property
    @pulumi.getter(name="marketplaceProviderBillingEntityName")
    def marketplace_provider_billing_entity_name(self) -> str:
        """
        Name of the marketplace provider billing entity.
        """
        return pulumi.get(self, "marketplace_provider_billing_entity_name")

    @property
    @pulumi.getter(name="oldAccountUrl")
    def old_account_url(self) -> str:
        """
        The previous account URL for a given account.
        """
        return pulumi.get(self, "old_account_url")

    @property
    @pulumi.getter(name="organizationName")
    def organization_name(self) -> str:
        """
        Name of the organization.
        """
        return pulumi.get(self, "organization_name")

    @property
    @pulumi.getter(name="regionGroup")
    def region_group(self) -> str:
        """
        Region group where the account is located. Note: this column is only visible to organizations that span multiple Region Groups.
        """
        return pulumi.get(self, "region_group")

    @property
    @pulumi.getter(name="snowflakeRegion")
    def snowflake_region(self) -> str:
        """
        Snowflake Region where the account is located. A Snowflake Region is a distinct location within a cloud platform region that is isolated from other Snowflake Regions. A Snowflake Region can be either multi-tenant or single-tenant (for a Virtual Private Snowflake account).
        """
        return pulumi.get(self, "snowflake_region")


@pulumi.output_type
class GetAlertsAlertResult(dict):
    def __init__(__self__, *,
                 action: str,
                 comment: str,
                 condition: str,
                 database_name: str,
                 name: str,
                 owner: str,
                 schema_name: str):
        """
        :param str action: The text of the SQL statement that should be executed when the alert is triggered.
        :param str comment: Comment for the alert.
        :param str condition: The text of the SQL statement that serves as the condition when the alert should be triggered.
        :param str database_name: Database in which the alert is stored.
        :param str name: Name of the alert.
        :param str owner: Role that owns the alert (i.e. has the OWNERSHIP privilege on the alert)
        :param str schema_name: Schema in which the alert is stored.
        """
        pulumi.set(__self__, "action", action)
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "condition", condition)
        pulumi.set(__self__, "database_name", database_name)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "owner", owner)
        pulumi.set(__self__, "schema_name", schema_name)

    @property
    @pulumi.getter
    def action(self) -> str:
        """
        The text of the SQL statement that should be executed when the alert is triggered.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter
    def comment(self) -> str:
        """
        Comment for the alert.
        """
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def condition(self) -> str:
        """
        The text of the SQL statement that serves as the condition when the alert should be triggered.
        """
        return pulumi.get(self, "condition")

    @property
    @pulumi.getter(name="databaseName")
    def database_name(self) -> str:
        """
        Database in which the alert is stored.
        """
        return pulumi.get(self, "database_name")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of the alert.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def owner(self) -> str:
        """
        Role that owns the alert (i.e. has the OWNERSHIP privilege on the alert)
        """
        return pulumi.get(self, "owner")

    @property
    @pulumi.getter(name="schemaName")
    def schema_name(self) -> str:
        """
        Schema in which the alert is stored.
        """
        return pulumi.get(self, "schema_name")


@pulumi.output_type
class GetDatabaseRolesDatabaseRoleResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 name: str,
                 owner: str):
        """
        :param str comment: The comment on the role
        :param str name: Identifier for the role.
        :param str owner: The owner of the role
        """
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "owner", owner)

    @property
    @pulumi.getter
    def comment(self) -> str:
        """
        The comment on the role
        """
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Identifier for the role.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def owner(self) -> str:
        """
        The owner of the role
        """
        return pulumi.get(self, "owner")


@pulumi.output_type
class GetDatabasesDatabaseResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 created_on: str,
                 is_current: bool,
                 is_default: bool,
                 name: str,
                 options: str,
                 origin: str,
                 owner: str,
                 replication_configurations: Sequence['outputs.GetDatabasesDatabaseReplicationConfigurationResult'],
                 retention_time: int):
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "created_on", created_on)
        pulumi.set(__self__, "is_current", is_current)
        pulumi.set(__self__, "is_default", is_default)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "options", options)
        pulumi.set(__self__, "origin", origin)
        pulumi.set(__self__, "owner", owner)
        pulumi.set(__self__, "replication_configurations", replication_configurations)
        pulumi.set(__self__, "retention_time", retention_time)

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter(name="createdOn")
    def created_on(self) -> str:
        return pulumi.get(self, "created_on")

    @property
    @pulumi.getter(name="isCurrent")
    def is_current(self) -> bool:
        return pulumi.get(self, "is_current")

    @property
    @pulumi.getter(name="isDefault")
    def is_default(self) -> bool:
        return pulumi.get(self, "is_default")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def options(self) -> str:
        return pulumi.get(self, "options")

    @property
    @pulumi.getter
    def origin(self) -> str:
        return pulumi.get(self, "origin")

    @property
    @pulumi.getter
    def owner(self) -> str:
        return pulumi.get(self, "owner")

    @property
    @pulumi.getter(name="replicationConfigurations")
    def replication_configurations(self) -> Sequence['outputs.GetDatabasesDatabaseReplicationConfigurationResult']:
        return pulumi.get(self, "replication_configurations")

    @property
    @pulumi.getter(name="retentionTime")
    def retention_time(self) -> int:
        return pulumi.get(self, "retention_time")


@pulumi.output_type
class GetDatabasesDatabaseReplicationConfigurationResult(dict):
    def __init__(__self__, *,
                 accounts: Sequence[str],
                 ignore_edition_check: bool):
        pulumi.set(__self__, "accounts", accounts)
        pulumi.set(__self__, "ignore_edition_check", ignore_edition_check)

    @property
    @pulumi.getter
    def accounts(self) -> Sequence[str]:
        return pulumi.get(self, "accounts")

    @property
    @pulumi.getter(name="ignoreEditionCheck")
    def ignore_edition_check(self) -> bool:
        return pulumi.get(self, "ignore_edition_check")


@pulumi.output_type
class GetDynamicTablesInResult(dict):
    def __init__(__self__, *,
                 account: Optional[bool] = None,
                 database: Optional[str] = None,
                 schema: Optional[str] = None):
        """
        :param bool account: Returns records for the entire account.
        :param str database: Returns records for the current database in use or for a specified database (db_name).
        :param str schema: Returns records for the current schema in use or a specified schema (schema_name).
        """
        if account is not None:
            pulumi.set(__self__, "account", account)
        if database is not None:
            pulumi.set(__self__, "database", database)
        if schema is not None:
            pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def account(self) -> Optional[bool]:
        """
        Returns records for the entire account.
        """
        return pulumi.get(self, "account")

    @property
    @pulumi.getter
    def database(self) -> Optional[str]:
        """
        Returns records for the current database in use or for a specified database (db_name).
        """
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def schema(self) -> Optional[str]:
        """
        Returns records for the current schema in use or a specified schema (schema_name).
        """
        return pulumi.get(self, "schema")


@pulumi.output_type
class GetDynamicTablesLikeResult(dict):
    def __init__(__self__, *,
                 pattern: str):
        """
        :param str pattern: Filters the command output by object name. The filter uses case-insensitive pattern matching with support for SQL wildcard characters (% and _).
        """
        pulumi.set(__self__, "pattern", pattern)

    @property
    @pulumi.getter
    def pattern(self) -> str:
        """
        Filters the command output by object name. The filter uses case-insensitive pattern matching with support for SQL wildcard characters (% and _).
        """
        return pulumi.get(self, "pattern")


@pulumi.output_type
class GetDynamicTablesLimitResult(dict):
    def __init__(__self__, *,
                 from_: Optional[str] = None,
                 rows: Optional[int] = None):
        """
        :param str from_: The optional FROM 'name_string' subclause effectively serves as a “cursor” for the results. This enables fetching the specified number of rows following the first row whose object name matches the specified string
        :param int rows: Specifies the maximum number of rows to return.
        """
        if from_ is not None:
            pulumi.set(__self__, "from_", from_)
        if rows is not None:
            pulumi.set(__self__, "rows", rows)

    @property
    @pulumi.getter(name="from")
    def from_(self) -> Optional[str]:
        """
        The optional FROM 'name_string' subclause effectively serves as a “cursor” for the results. This enables fetching the specified number of rows following the first row whose object name matches the specified string
        """
        return pulumi.get(self, "from_")

    @property
    @pulumi.getter
    def rows(self) -> Optional[int]:
        """
        Specifies the maximum number of rows to return.
        """
        return pulumi.get(self, "rows")


@pulumi.output_type
class GetDynamicTablesRecordResult(dict):
    def __init__(__self__, *,
                 automatic_clustering: bool,
                 bytes: int,
                 cluster_by: str,
                 comment: str,
                 created_on: str,
                 data_timestamp: str,
                 database_name: str,
                 is_clone: bool,
                 is_replica: bool,
                 last_suspended_on: str,
                 name: str,
                 owner: str,
                 refresh_mode: str,
                 refresh_mode_reason: str,
                 rows: int,
                 scheduling_state: str,
                 schema_name: str,
                 target_lag: str,
                 text: str,
                 warehouse: str):
        """
        :param bool automatic_clustering: Whether auto-clustering is enabled on the dynamic table. Not currently supported for dynamic tables.
        :param int bytes: Number of bytes that will be scanned if the entire dynamic table is scanned in a query.
        :param str cluster_by: The clustering key for the dynamic table.
        :param str comment: Comment for the dynamic table.
        :param str created_on: Date and time when the dynamic table was created.
        :param str data_timestamp: Timestamp of the data in the base object(s) that is included in the dynamic table.
        :param str database_name: Database in which the dynamic table is stored.
        :param bool is_clone: TRUE if the dynamic table has been cloned, else FALSE.
        :param bool is_replica: TRUE if the dynamic table is a replica. else FALSE.
        :param str last_suspended_on: Timestamp of last suspension.
        :param str name: Name of the dynamic table.
        :param str owner: Role that owns the dynamic table.
        :param str refresh_mode: INCREMENTAL if the dynamic table will use incremental refreshes, or FULL if it will recompute the whole table on every refresh.
        :param str refresh_mode_reason: Explanation for why FULL refresh mode was chosen. NULL if refresh mode is not FULL.
        :param int rows: Number of rows in the table.
        :param str scheduling_state: Displays RUNNING for dynamic tables that are actively scheduling refreshes and SUSPENDED for suspended dynamic tables.
        :param str schema_name: Schema in which the dynamic table is stored.
        :param str target_lag: The maximum duration that the dynamic table’s content should lag behind real time.
        :param str text: The text of the command that created this dynamic table (e.g. CREATE DYNAMIC TABLE ...).
        :param str warehouse: Warehouse that provides the required resources to perform the incremental refreshes.
        """
        pulumi.set(__self__, "automatic_clustering", automatic_clustering)
        pulumi.set(__self__, "bytes", bytes)
        pulumi.set(__self__, "cluster_by", cluster_by)
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "created_on", created_on)
        pulumi.set(__self__, "data_timestamp", data_timestamp)
        pulumi.set(__self__, "database_name", database_name)
        pulumi.set(__self__, "is_clone", is_clone)
        pulumi.set(__self__, "is_replica", is_replica)
        pulumi.set(__self__, "last_suspended_on", last_suspended_on)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "owner", owner)
        pulumi.set(__self__, "refresh_mode", refresh_mode)
        pulumi.set(__self__, "refresh_mode_reason", refresh_mode_reason)
        pulumi.set(__self__, "rows", rows)
        pulumi.set(__self__, "scheduling_state", scheduling_state)
        pulumi.set(__self__, "schema_name", schema_name)
        pulumi.set(__self__, "target_lag", target_lag)
        pulumi.set(__self__, "text", text)
        pulumi.set(__self__, "warehouse", warehouse)

    @property
    @pulumi.getter(name="automaticClustering")
    def automatic_clustering(self) -> bool:
        """
        Whether auto-clustering is enabled on the dynamic table. Not currently supported for dynamic tables.
        """
        return pulumi.get(self, "automatic_clustering")

    @property
    @pulumi.getter
    def bytes(self) -> int:
        """
        Number of bytes that will be scanned if the entire dynamic table is scanned in a query.
        """
        return pulumi.get(self, "bytes")

    @property
    @pulumi.getter(name="clusterBy")
    def cluster_by(self) -> str:
        """
        The clustering key for the dynamic table.
        """
        return pulumi.get(self, "cluster_by")

    @property
    @pulumi.getter
    def comment(self) -> str:
        """
        Comment for the dynamic table.
        """
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter(name="createdOn")
    def created_on(self) -> str:
        """
        Date and time when the dynamic table was created.
        """
        return pulumi.get(self, "created_on")

    @property
    @pulumi.getter(name="dataTimestamp")
    def data_timestamp(self) -> str:
        """
        Timestamp of the data in the base object(s) that is included in the dynamic table.
        """
        return pulumi.get(self, "data_timestamp")

    @property
    @pulumi.getter(name="databaseName")
    def database_name(self) -> str:
        """
        Database in which the dynamic table is stored.
        """
        return pulumi.get(self, "database_name")

    @property
    @pulumi.getter(name="isClone")
    def is_clone(self) -> bool:
        """
        TRUE if the dynamic table has been cloned, else FALSE.
        """
        return pulumi.get(self, "is_clone")

    @property
    @pulumi.getter(name="isReplica")
    def is_replica(self) -> bool:
        """
        TRUE if the dynamic table is a replica. else FALSE.
        """
        return pulumi.get(self, "is_replica")

    @property
    @pulumi.getter(name="lastSuspendedOn")
    def last_suspended_on(self) -> str:
        """
        Timestamp of last suspension.
        """
        return pulumi.get(self, "last_suspended_on")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of the dynamic table.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def owner(self) -> str:
        """
        Role that owns the dynamic table.
        """
        return pulumi.get(self, "owner")

    @property
    @pulumi.getter(name="refreshMode")
    def refresh_mode(self) -> str:
        """
        INCREMENTAL if the dynamic table will use incremental refreshes, or FULL if it will recompute the whole table on every refresh.
        """
        return pulumi.get(self, "refresh_mode")

    @property
    @pulumi.getter(name="refreshModeReason")
    def refresh_mode_reason(self) -> str:
        """
        Explanation for why FULL refresh mode was chosen. NULL if refresh mode is not FULL.
        """
        return pulumi.get(self, "refresh_mode_reason")

    @property
    @pulumi.getter
    def rows(self) -> int:
        """
        Number of rows in the table.
        """
        return pulumi.get(self, "rows")

    @property
    @pulumi.getter(name="schedulingState")
    def scheduling_state(self) -> str:
        """
        Displays RUNNING for dynamic tables that are actively scheduling refreshes and SUSPENDED for suspended dynamic tables.
        """
        return pulumi.get(self, "scheduling_state")

    @property
    @pulumi.getter(name="schemaName")
    def schema_name(self) -> str:
        """
        Schema in which the dynamic table is stored.
        """
        return pulumi.get(self, "schema_name")

    @property
    @pulumi.getter(name="targetLag")
    def target_lag(self) -> str:
        """
        The maximum duration that the dynamic table’s content should lag behind real time.
        """
        return pulumi.get(self, "target_lag")

    @property
    @pulumi.getter
    def text(self) -> str:
        """
        The text of the command that created this dynamic table (e.g. CREATE DYNAMIC TABLE ...).
        """
        return pulumi.get(self, "text")

    @property
    @pulumi.getter
    def warehouse(self) -> str:
        """
        Warehouse that provides the required resources to perform the incremental refreshes.
        """
        return pulumi.get(self, "warehouse")


@pulumi.output_type
class GetExternalFunctionsExternalFunctionResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 database: str,
                 language: str,
                 name: str,
                 schema: str):
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "database", database)
        pulumi.set(__self__, "language", language)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def database(self) -> str:
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def language(self) -> str:
        return pulumi.get(self, "language")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def schema(self) -> str:
        return pulumi.get(self, "schema")


@pulumi.output_type
class GetExternalTablesExternalTableResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 database: str,
                 name: str,
                 schema: str):
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "database", database)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def database(self) -> str:
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def schema(self) -> str:
        return pulumi.get(self, "schema")


@pulumi.output_type
class GetFailoverGroupsFailoverGroupResult(dict):
    def __init__(__self__, *,
                 account_locator: str,
                 account_name: str,
                 allowed_accounts: Sequence[Any],
                 allowed_integration_types: Sequence[Any],
                 comment: str,
                 created_on: str,
                 is_primary: bool,
                 next_scheduled_refresh: str,
                 object_types: Sequence[Any],
                 organization_name: str,
                 owner: str,
                 primary: str,
                 region_group: str,
                 replication_schedule: str,
                 secondary_state: str,
                 snowflake_region: str,
                 type: str):
        """
        :param str account_locator: Account locator in a region.
        :param str account_name: Name of the account.
        :param Sequence[Any] allowed_accounts: List of accounts enabled for replication and failover.
        :param Sequence[Any] allowed_integration_types: A list of integration types that are enabled for replication.
        :param str comment: Comment string.
        :param str created_on: Date and time failover group was created.
        :param bool is_primary: Indicates whether the failover group is the primary group.
        :param str next_scheduled_refresh: Date and time of the next scheduled refresh.
        :param Sequence[Any] object_types: List of specified object types enabled for replication and failover.
        :param str organization_name: Name of your Snowflake organization.
        :param str owner: Name of the role with the OWNERSHIP privilege on the failover group. NULL if the failover group is in a different region.
        :param str primary: Name of the primary group.
        :param str region_group: Region group where the account is located. Note: this column is only visible to organizations that span multiple Region Groups.
        :param str replication_schedule: Scheduled interval for refresh; NULL if no replication schedule is set.
        :param str secondary_state: Current state of scheduled refresh. Valid values are started or suspended. NULL if no replication schedule is set.
        :param str snowflake_region: Snowflake Region where the account is located. A Snowflake Region is a distinct location within a cloud platform region that is isolated from other Snowflake Regions. A Snowflake Region can be either multi-tenant or single-tenant (for a Virtual Private Snowflake account).
        :param str type: Type of group. Valid value is FAILOVER.
        """
        pulumi.set(__self__, "account_locator", account_locator)
        pulumi.set(__self__, "account_name", account_name)
        pulumi.set(__self__, "allowed_accounts", allowed_accounts)
        pulumi.set(__self__, "allowed_integration_types", allowed_integration_types)
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "created_on", created_on)
        pulumi.set(__self__, "is_primary", is_primary)
        pulumi.set(__self__, "next_scheduled_refresh", next_scheduled_refresh)
        pulumi.set(__self__, "object_types", object_types)
        pulumi.set(__self__, "organization_name", organization_name)
        pulumi.set(__self__, "owner", owner)
        pulumi.set(__self__, "primary", primary)
        pulumi.set(__self__, "region_group", region_group)
        pulumi.set(__self__, "replication_schedule", replication_schedule)
        pulumi.set(__self__, "secondary_state", secondary_state)
        pulumi.set(__self__, "snowflake_region", snowflake_region)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="accountLocator")
    def account_locator(self) -> str:
        """
        Account locator in a region.
        """
        return pulumi.get(self, "account_locator")

    @property
    @pulumi.getter(name="accountName")
    def account_name(self) -> str:
        """
        Name of the account.
        """
        return pulumi.get(self, "account_name")

    @property
    @pulumi.getter(name="allowedAccounts")
    def allowed_accounts(self) -> Sequence[Any]:
        """
        List of accounts enabled for replication and failover.
        """
        return pulumi.get(self, "allowed_accounts")

    @property
    @pulumi.getter(name="allowedIntegrationTypes")
    def allowed_integration_types(self) -> Sequence[Any]:
        """
        A list of integration types that are enabled for replication.
        """
        return pulumi.get(self, "allowed_integration_types")

    @property
    @pulumi.getter
    def comment(self) -> str:
        """
        Comment string.
        """
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter(name="createdOn")
    def created_on(self) -> str:
        """
        Date and time failover group was created.
        """
        return pulumi.get(self, "created_on")

    @property
    @pulumi.getter(name="isPrimary")
    def is_primary(self) -> bool:
        """
        Indicates whether the failover group is the primary group.
        """
        return pulumi.get(self, "is_primary")

    @property
    @pulumi.getter(name="nextScheduledRefresh")
    def next_scheduled_refresh(self) -> str:
        """
        Date and time of the next scheduled refresh.
        """
        return pulumi.get(self, "next_scheduled_refresh")

    @property
    @pulumi.getter(name="objectTypes")
    def object_types(self) -> Sequence[Any]:
        """
        List of specified object types enabled for replication and failover.
        """
        return pulumi.get(self, "object_types")

    @property
    @pulumi.getter(name="organizationName")
    def organization_name(self) -> str:
        """
        Name of your Snowflake organization.
        """
        return pulumi.get(self, "organization_name")

    @property
    @pulumi.getter
    def owner(self) -> str:
        """
        Name of the role with the OWNERSHIP privilege on the failover group. NULL if the failover group is in a different region.
        """
        return pulumi.get(self, "owner")

    @property
    @pulumi.getter
    def primary(self) -> str:
        """
        Name of the primary group.
        """
        return pulumi.get(self, "primary")

    @property
    @pulumi.getter(name="regionGroup")
    def region_group(self) -> str:
        """
        Region group where the account is located. Note: this column is only visible to organizations that span multiple Region Groups.
        """
        return pulumi.get(self, "region_group")

    @property
    @pulumi.getter(name="replicationSchedule")
    def replication_schedule(self) -> str:
        """
        Scheduled interval for refresh; NULL if no replication schedule is set.
        """
        return pulumi.get(self, "replication_schedule")

    @property
    @pulumi.getter(name="secondaryState")
    def secondary_state(self) -> str:
        """
        Current state of scheduled refresh. Valid values are started or suspended. NULL if no replication schedule is set.
        """
        return pulumi.get(self, "secondary_state")

    @property
    @pulumi.getter(name="snowflakeRegion")
    def snowflake_region(self) -> str:
        """
        Snowflake Region where the account is located. A Snowflake Region is a distinct location within a cloud platform region that is isolated from other Snowflake Regions. A Snowflake Region can be either multi-tenant or single-tenant (for a Virtual Private Snowflake account).
        """
        return pulumi.get(self, "snowflake_region")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Type of group. Valid value is FAILOVER.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class GetFileFormatsFileFormatResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 database: str,
                 format_type: str,
                 name: str,
                 schema: str):
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "database", database)
        pulumi.set(__self__, "format_type", format_type)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def database(self) -> str:
        return pulumi.get(self, "database")

    @property
    @pulumi.getter(name="formatType")
    def format_type(self) -> str:
        return pulumi.get(self, "format_type")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def schema(self) -> str:
        return pulumi.get(self, "schema")


@pulumi.output_type
class GetFunctionsFunctionResult(dict):
    def __init__(__self__, *,
                 argument_types: Sequence[str],
                 comment: str,
                 database: str,
                 name: str,
                 return_type: str,
                 schema: str):
        pulumi.set(__self__, "argument_types", argument_types)
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "database", database)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "return_type", return_type)
        pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter(name="argumentTypes")
    def argument_types(self) -> Sequence[str]:
        return pulumi.get(self, "argument_types")

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def database(self) -> str:
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="returnType")
    def return_type(self) -> str:
        return pulumi.get(self, "return_type")

    @property
    @pulumi.getter
    def schema(self) -> str:
        return pulumi.get(self, "schema")


@pulumi.output_type
class GetGrantsFutureGrantsInResult(dict):
    def __init__(__self__, *,
                 database: Optional[str] = None,
                 schema: Optional[str] = None):
        """
        :param str database: Lists all privileges on new (i.e. future) objects of a specified type in the database granted to a role.
        :param str schema: Lists all privileges on new (i.e. future) objects of a specified type in the schema granted to a role. Schema must be a fully qualified name ("&lt;db*name&gt;"."&lt;schema*name&gt;").
        """
        if database is not None:
            pulumi.set(__self__, "database", database)
        if schema is not None:
            pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def database(self) -> Optional[str]:
        """
        Lists all privileges on new (i.e. future) objects of a specified type in the database granted to a role.
        """
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def schema(self) -> Optional[str]:
        """
        Lists all privileges on new (i.e. future) objects of a specified type in the schema granted to a role. Schema must be a fully qualified name ("&lt;db*name&gt;"."&lt;schema*name&gt;").
        """
        return pulumi.get(self, "schema")


@pulumi.output_type
class GetGrantsFutureGrantsToResult(dict):
    def __init__(__self__, *,
                 account_role: Optional[str] = None,
                 database_role: Optional[str] = None):
        """
        :param str account_role: Lists all privileges on new (i.e. future) objects of a specified type in a database or schema granted to the account role.
        :param str database_role: Lists all privileges on new (i.e. future) objects granted to the database role. Must be a fully qualified name ("&lt;db*name&gt;"."&lt;database*role_name&gt;").
        """
        if account_role is not None:
            pulumi.set(__self__, "account_role", account_role)
        if database_role is not None:
            pulumi.set(__self__, "database_role", database_role)

    @property
    @pulumi.getter(name="accountRole")
    def account_role(self) -> Optional[str]:
        """
        Lists all privileges on new (i.e. future) objects of a specified type in a database or schema granted to the account role.
        """
        return pulumi.get(self, "account_role")

    @property
    @pulumi.getter(name="databaseRole")
    def database_role(self) -> Optional[str]:
        """
        Lists all privileges on new (i.e. future) objects granted to the database role. Must be a fully qualified name ("&lt;db*name&gt;"."&lt;database*role_name&gt;").
        """
        return pulumi.get(self, "database_role")


@pulumi.output_type
class GetGrantsGrantResult(dict):
    def __init__(__self__, *,
                 created_on: str,
                 grant_option: bool,
                 granted_by: str,
                 granted_on: str,
                 granted_to: str,
                 grantee_name: str,
                 name: str,
                 privilege: str):
        """
        :param str created_on: The date and time the grant was created.
        :param bool grant_option: Whether the grantee can grant the privilege to others.
        :param str granted_by: The role that granted the privilege.
        :param str granted_on: The object on which the privilege was granted.
        :param str granted_to: The role to which the privilege was granted.
        :param str grantee_name: The name of the role to which the privilege was granted.
        :param str name: The name of the object on which the privilege was granted.
        :param str privilege: The privilege granted.
        """
        pulumi.set(__self__, "created_on", created_on)
        pulumi.set(__self__, "grant_option", grant_option)
        pulumi.set(__self__, "granted_by", granted_by)
        pulumi.set(__self__, "granted_on", granted_on)
        pulumi.set(__self__, "granted_to", granted_to)
        pulumi.set(__self__, "grantee_name", grantee_name)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "privilege", privilege)

    @property
    @pulumi.getter(name="createdOn")
    def created_on(self) -> str:
        """
        The date and time the grant was created.
        """
        return pulumi.get(self, "created_on")

    @property
    @pulumi.getter(name="grantOption")
    def grant_option(self) -> bool:
        """
        Whether the grantee can grant the privilege to others.
        """
        return pulumi.get(self, "grant_option")

    @property
    @pulumi.getter(name="grantedBy")
    def granted_by(self) -> str:
        """
        The role that granted the privilege.
        """
        return pulumi.get(self, "granted_by")

    @property
    @pulumi.getter(name="grantedOn")
    def granted_on(self) -> str:
        """
        The object on which the privilege was granted.
        """
        return pulumi.get(self, "granted_on")

    @property
    @pulumi.getter(name="grantedTo")
    def granted_to(self) -> str:
        """
        The role to which the privilege was granted.
        """
        return pulumi.get(self, "granted_to")

    @property
    @pulumi.getter(name="granteeName")
    def grantee_name(self) -> str:
        """
        The name of the role to which the privilege was granted.
        """
        return pulumi.get(self, "grantee_name")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the object on which the privilege was granted.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def privilege(self) -> str:
        """
        The privilege granted.
        """
        return pulumi.get(self, "privilege")


@pulumi.output_type
class GetGrantsGrantsOfResult(dict):
    def __init__(__self__, *,
                 account_role: Optional[str] = None,
                 application_role: Optional[str] = None,
                 database_role: Optional[str] = None,
                 share: Optional[str] = None):
        """
        :param str account_role: Lists all users and roles to which the account role has been granted.
        :param str application_role: Lists all the users and roles to which the application role has been granted. Must be a fully qualified name ("&lt;db*name&gt;"."&lt;database*role_name&gt;").
        :param str database_role: Lists all users and roles to which the database role has been granted. Must be a fully qualified name ("&lt;db*name&gt;"."&lt;database*role_name&gt;").
        :param str share: Lists all the accounts for the share and indicates the accounts that are using the share.
        """
        if account_role is not None:
            pulumi.set(__self__, "account_role", account_role)
        if application_role is not None:
            pulumi.set(__self__, "application_role", application_role)
        if database_role is not None:
            pulumi.set(__self__, "database_role", database_role)
        if share is not None:
            pulumi.set(__self__, "share", share)

    @property
    @pulumi.getter(name="accountRole")
    def account_role(self) -> Optional[str]:
        """
        Lists all users and roles to which the account role has been granted.
        """
        return pulumi.get(self, "account_role")

    @property
    @pulumi.getter(name="applicationRole")
    def application_role(self) -> Optional[str]:
        """
        Lists all the users and roles to which the application role has been granted. Must be a fully qualified name ("&lt;db*name&gt;"."&lt;database*role_name&gt;").
        """
        return pulumi.get(self, "application_role")

    @property
    @pulumi.getter(name="databaseRole")
    def database_role(self) -> Optional[str]:
        """
        Lists all users and roles to which the database role has been granted. Must be a fully qualified name ("&lt;db*name&gt;"."&lt;database*role_name&gt;").
        """
        return pulumi.get(self, "database_role")

    @property
    @pulumi.getter
    def share(self) -> Optional[str]:
        """
        Lists all the accounts for the share and indicates the accounts that are using the share.
        """
        return pulumi.get(self, "share")


@pulumi.output_type
class GetGrantsGrantsOnResult(dict):
    def __init__(__self__, *,
                 account: Optional[bool] = None,
                 object_name: Optional[str] = None,
                 object_type: Optional[str] = None):
        """
        :param bool account: Object hierarchy to list privileges on. The only valid value is: ACCOUNT. Setting this attribute lists all the account-level (i.e. global) privileges that have been granted to roles.
        :param str object_name: Name of object to list privileges on.
        :param str object_type: Type of object to list privileges on.
        """
        if account is not None:
            pulumi.set(__self__, "account", account)
        if object_name is not None:
            pulumi.set(__self__, "object_name", object_name)
        if object_type is not None:
            pulumi.set(__self__, "object_type", object_type)

    @property
    @pulumi.getter
    def account(self) -> Optional[bool]:
        """
        Object hierarchy to list privileges on. The only valid value is: ACCOUNT. Setting this attribute lists all the account-level (i.e. global) privileges that have been granted to roles.
        """
        return pulumi.get(self, "account")

    @property
    @pulumi.getter(name="objectName")
    def object_name(self) -> Optional[str]:
        """
        Name of object to list privileges on.
        """
        return pulumi.get(self, "object_name")

    @property
    @pulumi.getter(name="objectType")
    def object_type(self) -> Optional[str]:
        """
        Type of object to list privileges on.
        """
        return pulumi.get(self, "object_type")


@pulumi.output_type
class GetGrantsGrantsToResult(dict):
    def __init__(__self__, *,
                 account_role: Optional[str] = None,
                 application: Optional[str] = None,
                 application_role: Optional[str] = None,
                 database_role: Optional[str] = None,
                 share: Optional['outputs.GetGrantsGrantsToShareResult'] = None,
                 user: Optional[str] = None):
        """
        :param str account_role: Lists all privileges and roles granted to the role.
        :param str application: Lists all the privileges and roles granted to the application.
        :param str application_role: Lists all the privileges and roles granted to the application role. Must be a fully qualified name ("&lt;app*name&gt;"."&lt;app*role_name&gt;").
        :param str database_role: Lists all privileges and roles granted to the database role. Must be a fully qualified name ("&lt;db*name&gt;"."&lt;database*role_name&gt;").
        :param 'GetGrantsGrantsToShareArgs' share: Lists all the privileges granted to the share.
        :param str user: Lists all the roles granted to the user. Note that the PUBLIC role, which is automatically available to every user, is not listed.
        """
        if account_role is not None:
            pulumi.set(__self__, "account_role", account_role)
        if application is not None:
            pulumi.set(__self__, "application", application)
        if application_role is not None:
            pulumi.set(__self__, "application_role", application_role)
        if database_role is not None:
            pulumi.set(__self__, "database_role", database_role)
        if share is not None:
            pulumi.set(__self__, "share", share)
        if user is not None:
            pulumi.set(__self__, "user", user)

    @property
    @pulumi.getter(name="accountRole")
    def account_role(self) -> Optional[str]:
        """
        Lists all privileges and roles granted to the role.
        """
        return pulumi.get(self, "account_role")

    @property
    @pulumi.getter
    def application(self) -> Optional[str]:
        """
        Lists all the privileges and roles granted to the application.
        """
        return pulumi.get(self, "application")

    @property
    @pulumi.getter(name="applicationRole")
    def application_role(self) -> Optional[str]:
        """
        Lists all the privileges and roles granted to the application role. Must be a fully qualified name ("&lt;app*name&gt;"."&lt;app*role_name&gt;").
        """
        return pulumi.get(self, "application_role")

    @property
    @pulumi.getter(name="databaseRole")
    def database_role(self) -> Optional[str]:
        """
        Lists all privileges and roles granted to the database role. Must be a fully qualified name ("&lt;db*name&gt;"."&lt;database*role_name&gt;").
        """
        return pulumi.get(self, "database_role")

    @property
    @pulumi.getter
    def share(self) -> Optional['outputs.GetGrantsGrantsToShareResult']:
        """
        Lists all the privileges granted to the share.
        """
        return pulumi.get(self, "share")

    @property
    @pulumi.getter
    def user(self) -> Optional[str]:
        """
        Lists all the roles granted to the user. Note that the PUBLIC role, which is automatically available to every user, is not listed.
        """
        return pulumi.get(self, "user")


@pulumi.output_type
class GetGrantsGrantsToShareResult(dict):
    def __init__(__self__, *,
                 share_name: str):
        """
        :param str share_name: Lists all of the privileges and roles granted to the specified share.
        """
        pulumi.set(__self__, "share_name", share_name)

    @property
    @pulumi.getter(name="shareName")
    def share_name(self) -> str:
        """
        Lists all of the privileges and roles granted to the specified share.
        """
        return pulumi.get(self, "share_name")


@pulumi.output_type
class GetMaskingPoliciesMaskingPolicyResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 database: str,
                 kind: str,
                 name: str,
                 schema: str):
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "database", database)
        pulumi.set(__self__, "kind", kind)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def database(self) -> str:
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def kind(self) -> str:
        return pulumi.get(self, "kind")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def schema(self) -> str:
        return pulumi.get(self, "schema")


@pulumi.output_type
class GetMaterializedViewsMaterializedViewResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 database: str,
                 name: str,
                 schema: str):
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "database", database)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def database(self) -> str:
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def schema(self) -> str:
        return pulumi.get(self, "schema")


@pulumi.output_type
class GetParametersParameterResult(dict):
    def __init__(__self__, *,
                 default: str,
                 description: str,
                 key: str,
                 level: str,
                 value: str):
        """
        :param str default: The default value of the parameter
        :param str description: The description of the parameter
        :param str key: The name of the parameter
        :param str level: The level of the parameter
        :param str value: The value of the parameter
        """
        pulumi.set(__self__, "default", default)
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "key", key)
        pulumi.set(__self__, "level", level)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def default(self) -> str:
        """
        The default value of the parameter
        """
        return pulumi.get(self, "default")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description of the parameter
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def key(self) -> str:
        """
        The name of the parameter
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def level(self) -> str:
        """
        The level of the parameter
        """
        return pulumi.get(self, "level")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        The value of the parameter
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class GetPipesPipeResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 database: str,
                 integration: str,
                 name: str,
                 schema: str):
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "database", database)
        pulumi.set(__self__, "integration", integration)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def database(self) -> str:
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def integration(self) -> str:
        return pulumi.get(self, "integration")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def schema(self) -> str:
        return pulumi.get(self, "schema")


@pulumi.output_type
class GetProceduresProcedureResult(dict):
    def __init__(__self__, *,
                 argument_types: Sequence[str],
                 comment: str,
                 database: str,
                 name: str,
                 return_type: str,
                 schema: str):
        pulumi.set(__self__, "argument_types", argument_types)
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "database", database)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "return_type", return_type)
        pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter(name="argumentTypes")
    def argument_types(self) -> Sequence[str]:
        return pulumi.get(self, "argument_types")

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def database(self) -> str:
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="returnType")
    def return_type(self) -> str:
        return pulumi.get(self, "return_type")

    @property
    @pulumi.getter
    def schema(self) -> str:
        return pulumi.get(self, "schema")


@pulumi.output_type
class GetResourceMonitorsResourceMonitorResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 credit_quota: str,
                 frequency: str,
                 name: str):
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "credit_quota", credit_quota)
        pulumi.set(__self__, "frequency", frequency)
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter(name="creditQuota")
    def credit_quota(self) -> str:
        return pulumi.get(self, "credit_quota")

    @property
    @pulumi.getter
    def frequency(self) -> str:
        return pulumi.get(self, "frequency")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")


@pulumi.output_type
class GetRolesRoleResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 name: str,
                 owner: str):
        """
        :param str comment: The comment on the role
        :param str name: Identifier for the role.
        :param str owner: The owner of the role
        """
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "owner", owner)

    @property
    @pulumi.getter
    def comment(self) -> str:
        """
        The comment on the role
        """
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Identifier for the role.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def owner(self) -> str:
        """
        The owner of the role
        """
        return pulumi.get(self, "owner")


@pulumi.output_type
class GetRowAccessPoliciesRowAccessPolicyResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 database: str,
                 name: str,
                 schema: str):
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "database", database)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def database(self) -> str:
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def schema(self) -> str:
        return pulumi.get(self, "schema")


@pulumi.output_type
class GetSchemasSchemaResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 database: str,
                 name: str):
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "database", database)
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def database(self) -> str:
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")


@pulumi.output_type
class GetSequencesSequenceResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 database: str,
                 name: str,
                 schema: str):
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "database", database)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def database(self) -> str:
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def schema(self) -> str:
        return pulumi.get(self, "schema")


@pulumi.output_type
class GetSharesShareResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 kind: str,
                 name: str,
                 owner: str,
                 tos: Sequence[Any]):
        """
        :param str comment: The comment on the share.
        :param str kind: The kind of the share.
        :param str name: Identifier for the share.
        :param str owner: The owner of the share.
        :param Sequence[Any] tos: For the OUTBOUND share, list of consumers.
        """
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "kind", kind)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "owner", owner)
        pulumi.set(__self__, "tos", tos)

    @property
    @pulumi.getter
    def comment(self) -> str:
        """
        The comment on the share.
        """
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def kind(self) -> str:
        """
        The kind of the share.
        """
        return pulumi.get(self, "kind")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Identifier for the share.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def owner(self) -> str:
        """
        The owner of the share.
        """
        return pulumi.get(self, "owner")

    @property
    @pulumi.getter
    def tos(self) -> Sequence[Any]:
        """
        For the OUTBOUND share, list of consumers.
        """
        return pulumi.get(self, "tos")


@pulumi.output_type
class GetStagesStageResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 database: str,
                 name: str,
                 schema: str,
                 storage_integration: str):
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "database", database)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "schema", schema)
        pulumi.set(__self__, "storage_integration", storage_integration)

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def database(self) -> str:
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def schema(self) -> str:
        return pulumi.get(self, "schema")

    @property
    @pulumi.getter(name="storageIntegration")
    def storage_integration(self) -> str:
        return pulumi.get(self, "storage_integration")


@pulumi.output_type
class GetStorageIntegrationsStorageIntegrationResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 enabled: bool,
                 name: str,
                 type: str):
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "enabled", enabled)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def enabled(self) -> bool:
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def type(self) -> str:
        return pulumi.get(self, "type")


@pulumi.output_type
class GetStreamsStreamResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 database: str,
                 name: str,
                 schema: str,
                 table: str):
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "database", database)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "schema", schema)
        pulumi.set(__self__, "table", table)

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def database(self) -> str:
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def schema(self) -> str:
        return pulumi.get(self, "schema")

    @property
    @pulumi.getter
    def table(self) -> str:
        return pulumi.get(self, "table")


@pulumi.output_type
class GetTablesTableResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 database: str,
                 name: str,
                 schema: str):
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "database", database)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def database(self) -> str:
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def schema(self) -> str:
        return pulumi.get(self, "schema")


@pulumi.output_type
class GetTasksTaskResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 database: str,
                 name: str,
                 schema: str,
                 warehouse: str):
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "database", database)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "schema", schema)
        pulumi.set(__self__, "warehouse", warehouse)

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def database(self) -> str:
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def schema(self) -> str:
        return pulumi.get(self, "schema")

    @property
    @pulumi.getter
    def warehouse(self) -> str:
        return pulumi.get(self, "warehouse")


@pulumi.output_type
class GetUsersUserResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 default_namespace: str,
                 default_role: str,
                 default_secondary_roles: Sequence[str],
                 default_warehouse: str,
                 disabled: bool,
                 display_name: str,
                 email: str,
                 first_name: str,
                 has_rsa_public_key: bool,
                 last_name: str,
                 login_name: str,
                 name: str):
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "default_namespace", default_namespace)
        pulumi.set(__self__, "default_role", default_role)
        pulumi.set(__self__, "default_secondary_roles", default_secondary_roles)
        pulumi.set(__self__, "default_warehouse", default_warehouse)
        pulumi.set(__self__, "disabled", disabled)
        pulumi.set(__self__, "display_name", display_name)
        pulumi.set(__self__, "email", email)
        pulumi.set(__self__, "first_name", first_name)
        pulumi.set(__self__, "has_rsa_public_key", has_rsa_public_key)
        pulumi.set(__self__, "last_name", last_name)
        pulumi.set(__self__, "login_name", login_name)
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter(name="defaultNamespace")
    def default_namespace(self) -> str:
        return pulumi.get(self, "default_namespace")

    @property
    @pulumi.getter(name="defaultRole")
    def default_role(self) -> str:
        return pulumi.get(self, "default_role")

    @property
    @pulumi.getter(name="defaultSecondaryRoles")
    def default_secondary_roles(self) -> Sequence[str]:
        return pulumi.get(self, "default_secondary_roles")

    @property
    @pulumi.getter(name="defaultWarehouse")
    def default_warehouse(self) -> str:
        return pulumi.get(self, "default_warehouse")

    @property
    @pulumi.getter
    def disabled(self) -> bool:
        return pulumi.get(self, "disabled")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> str:
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter
    def email(self) -> str:
        return pulumi.get(self, "email")

    @property
    @pulumi.getter(name="firstName")
    def first_name(self) -> str:
        return pulumi.get(self, "first_name")

    @property
    @pulumi.getter(name="hasRsaPublicKey")
    def has_rsa_public_key(self) -> bool:
        return pulumi.get(self, "has_rsa_public_key")

    @property
    @pulumi.getter(name="lastName")
    def last_name(self) -> str:
        return pulumi.get(self, "last_name")

    @property
    @pulumi.getter(name="loginName")
    def login_name(self) -> str:
        return pulumi.get(self, "login_name")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")


@pulumi.output_type
class GetViewsViewResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 database: str,
                 name: str,
                 schema: str):
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "database", database)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "schema", schema)

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def database(self) -> str:
        return pulumi.get(self, "database")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def schema(self) -> str:
        return pulumi.get(self, "schema")


@pulumi.output_type
class GetWarehousesWarehouseResult(dict):
    def __init__(__self__, *,
                 comment: str,
                 name: str,
                 scaling_policy: str,
                 size: str,
                 state: str,
                 type: str):
        pulumi.set(__self__, "comment", comment)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "scaling_policy", scaling_policy)
        pulumi.set(__self__, "size", size)
        pulumi.set(__self__, "state", state)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def comment(self) -> str:
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="scalingPolicy")
    def scaling_policy(self) -> str:
        return pulumi.get(self, "scaling_policy")

    @property
    @pulumi.getter
    def size(self) -> str:
        return pulumi.get(self, "size")

    @property
    @pulumi.getter
    def state(self) -> str:
        return pulumi.get(self, "state")

    @property
    @pulumi.getter
    def type(self) -> str:
        return pulumi.get(self, "type")


